package fr.inria.gforge.dspace.overlay.benchmarks.analyzer.gui;

import java.util.List;

import javax.swing.table.AbstractTableModel;

import fr.inria.gforge.dspace.overlay.benchmarks.analyzer.parser.BenchmarkBean;

/**
 * 
 * @author Laurent Pellegrino
 *
 * @version $Id: BenchmarksTableModel.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class BenchmarksTableModel extends AbstractTableModel {

	private static final long serialVersionUID = 1L;

	private List<BenchmarkBean> beans;
	
	public BenchmarksTableModel(List<BenchmarkBean> benchs) {
		this.beans = benchs;
	}

	@Override
	public int getRowCount() {
		if (this.beans == null) {
			return 0;
		}
		
		return this.beans.size();
	}

	@Override
	public int getColumnCount() {
		if (this.beans == null) {
			return 0;
		}
		
		return this.beans.get(0).
				getTasksTimeMeasurementResults().
					getMeasurementsResults().size() + 1;
	}

	@Override
	public Object getValueAt(int rowIndex, int columnIndex) {
		if (columnIndex == 0) {
			return this.beans.get(rowIndex).getNbPeers();
		} else {
			return this.beans.get(rowIndex).
					getTasksTimeMeasurementResults().
						getMeasurementsResults().
							get(columnIndex-1).getExecutionTime();
		}
	}
	
	@Override
	public String getColumnName(int column) {
		if (column == 0) {
			return "nbPeers";
		} else {
			return this.beans.get(0).
						getTasksTimeMeasurementResults().
							getMeasurementsResults().get(column - 1).getTaskSimpleName();
		}
	}

}
