package fr.inria.gforge.dspace.overlay.benchmarks.analyzer.gui.charts;

import java.awt.Color;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.category.DefaultCategoryDataset;

import fr.inria.gforge.dspace.overlay.benchmarks.analyzer.parser.BenchmarkBean;
import fr.inria.gforge.dspace.overlay.benchmarks.measurement.PeerMeasurementResults;

/**
 * 
 * @author Laurent Pellegrino
 *
 * @version $Id: StatementsDistributionChart.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class StatementsDistributionChart extends AbstractChart {

	private static final long serialVersionUID = 1L;

	public StatementsDistributionChart(BenchmarkBean bean) {
		super(bean);
	}

	public ChartPanel create() {
		DefaultCategoryDataset dataset = new DefaultCategoryDataset();
		
		for (PeerMeasurementResults result : super.bean.getPeersMeasurementResults().getMeasurementsResults()) {
			dataset.addValue(
					result.getNbStatementsManaged(), 
					"Nb statements by peers", 
					result.getIdentifier());
		}

		final JFreeChart chart = ChartFactory.createBarChart(
				"Statements distribution by peers", 
				"Peer ID", 
				"Number of statements",
				dataset, 
				PlotOrientation.VERTICAL, 
				true, 
				false,
				false);
		chart.setBackgroundPaint(new Color(246, 246, 246));
		
		final CategoryPlot plot = chart.getCategoryPlot();
		plot.setBackgroundPaint(Color.WHITE);
		plot.setDomainGridlinePaint(Color.LIGHT_GRAY);
		plot.setRangeGridlinePaint(Color.LIGHT_GRAY);
		
		final ChartPanel chartPanel = new ChartPanel(chart);
		chartPanel.setPreferredSize(new java.awt.Dimension(700, 350));
		return chartPanel;
	}

}
