package fr.inria.gforge.dspace.overlay.benchmarks.measurement;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;

/**
 * @author Laurent Pellegrino
 *
 * @version $Id: AbstractMeasurementResults.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public abstract class AbstractMeasurementResults {

	private String associatedTaskSimpleName;
	
	public AbstractMeasurementResults() {
		
	}
	
	public AbstractMeasurementResults(String associatedTaskSimpleName) {
		this.associatedTaskSimpleName = associatedTaskSimpleName;
	}
	
	public String getAssociatedTaskSimpleName() {
		return this.associatedTaskSimpleName;
	}

	protected abstract void write(BufferedWriter writer) throws IOException;
	
	protected abstract void read(BufferedReader reader) throws IOException;
	
	public void writeResults(BufferedWriter writer) throws IOException {
		writer.write('#');
		if (this.associatedTaskSimpleName != null) {
			writer.write(' ');
			writer.write(this.associatedTaskSimpleName);
		}
		writer.write(' ');
		writer.write(this.getClass().getSimpleName());
		writer.newLine();
		this.write(writer);
		writer.newLine();
	}
	
	public void readResults(BufferedReader reader) throws IOException {
		this.read(reader);
	}
	
}
