package fr.inria.gforge.dspace.overlay.benchmarks.measurement;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: AddStatementsMeasurementResults.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class AddStatementsMeasurementResults extends AbstractMeasurementResults {

	private List<AddStatementMeasurementResults> measurementsResults = 
							new ArrayList<AddStatementMeasurementResults>();
	
	public AddStatementsMeasurementResults() {
		super();
	}
	
	public AddStatementsMeasurementResults(String associatedTaskSimpleName) {
		super(associatedTaskSimpleName);
	}
	
	public boolean add(AddStatementMeasurementResults e) {
		return this.measurementsResults.add(e);
	}

	public List<AddStatementMeasurementResults> getMeasurementsResults() {
		return this.measurementsResults;
	}

	protected void write(BufferedWriter writer) throws IOException {
		Collections.sort(this.measurementsResults);
		
		for (AddStatementMeasurementResults result : this.measurementsResults) {
			result.write(writer);
		}
	}

	protected void read(BufferedReader reader) throws IOException {
		String line;
		AddStatementMeasurementResults result;
		
		while (!(line = reader.readLine()).equals("")) {
			result = new AddStatementMeasurementResults();
			result.read(new BufferedReader(new StringReader(line)));
			this.add(result);
		}
	}

}
