package fr.inria.gforge.dspace.overlay.benchmarks.measurement;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.util.UUID;

/**
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: PeerMeasurementResults.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class PeerMeasurementResults extends AbstractMeasurementResults {

    private UUID identifier;

    private int nbStatementsManaged;

    public PeerMeasurementResults() {
    	super();
    }
    
    public PeerMeasurementResults(String associatedTaskSimpleName) {
    	super(associatedTaskSimpleName);
    }
    
    public PeerMeasurementResults(UUID identifier, int nbStatementsManaged) {
        super();
        this.identifier = identifier;
        this.nbStatementsManaged = nbStatementsManaged;
    }

    public UUID getIdentifier() {
        return this.identifier;
    }

    public int getNbStatementsManaged() {
        return this.nbStatementsManaged;
    }

    public void setIdentifier(UUID identifier) {
		this.identifier = identifier;
	}

	public void setNbStatementsManaged(int nbStatementsManaged) {
		this.nbStatementsManaged = nbStatementsManaged;
	}

	public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("id=");
        buf.append(this.identifier);
        buf.append(", nbStatementsmanaged=");
        buf.append(this.nbStatementsManaged);
        
        return buf.toString();
    }

	protected void write(BufferedWriter writer) throws IOException {
		writer.write(this.identifier.toString());
		writer.write(' ');
		writer.write(Integer.toString(this.nbStatementsManaged));
		writer.newLine();
	}

	protected void read(BufferedReader reader) throws IOException {
		String[] line = reader.readLine().split(" ");
		this.identifier = UUID.fromString(line[0]);
		this.nbStatementsManaged = Integer.parseInt(line[1]);
	}
    
}
