package fr.inria.gforge.dspace.overlay.benchmarks.measurement;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: QueryMeasurementResults.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class QueryMeasurementResults 
						extends AbstractMeasurementResults {

    private int nbHopsSingleTrip;

    private int nbHopsReturnTrip;

    private int latency;
    
    private int nbStatements;
    
    public QueryMeasurementResults() {
    	super();
    }
    
    public QueryMeasurementResults(String associatedTaskSimpleName) {
    	super(associatedTaskSimpleName);
    }

	public QueryMeasurementResults(
			String associatedTaskSimpleName,
			int nbHopsSingleTrip, 
			int nbHopsReturnTrip,
			int latency,
			int nbStatements) {
		super(associatedTaskSimpleName);
		this.nbHopsSingleTrip = nbHopsSingleTrip;
		this.nbHopsReturnTrip = nbHopsReturnTrip;
		this.latency = latency;
		this.nbStatements = nbStatements;
	}

	public int getNbHopsSingleTrip() {
		return this.nbHopsSingleTrip;
	}

	public int getNbHopsReturnTrip() {
		return this.nbHopsReturnTrip;
	}

	public int getLatency() {
		return this.latency;
	}

	protected void write(BufferedWriter writer) throws IOException {
		writer.write(Integer.toString(this.nbHopsSingleTrip));
		writer.write(' ');
		writer.write(Integer.toString(this.nbHopsReturnTrip));
		writer.write(' ');
		writer.write(Integer.toString(this.latency));
		writer.write(' ');
		writer.write(Integer.toString(this.nbStatements));
		writer.newLine();
	}

	protected void read(BufferedReader reader) throws IOException {
		String[] line = reader.readLine().split(" ");
		this.nbHopsSingleTrip = Integer.parseInt(line[0]);
		this.nbHopsReturnTrip = Integer.parseInt(line[1]);
		this.latency = Integer.parseInt(line[2]);
		this.nbStatements = Integer.parseInt(line[3]);
		reader.readLine();
	}

}
