package fr.inria.gforge.dspace.overlay.benchmarks.measurement;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;

/**
 * @author Laurent Pellegrino
 *
 * @version $Id: TaskTimeMeasurementResults.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class TaskTimeMeasurementResults extends AbstractMeasurementResults {

	private String taskSimpleName;
	
	private long executionTime;
	
	public TaskTimeMeasurementResults() {
		super();
	}
	
	public TaskTimeMeasurementResults(String associatedTaskSimpleName) {
		super(associatedTaskSimpleName);
	}
	
	public TaskTimeMeasurementResults(String taskSimpleName, long executionTime) {
		this.taskSimpleName = taskSimpleName;
		this.executionTime = executionTime;
	}

	public String getTaskSimpleName() {
		return this.taskSimpleName;
	}

	public long getExecutionTime() {
		return this.executionTime;
	}

	protected void write(BufferedWriter writer) throws IOException {
		writer.write(this.getTaskSimpleName());
		writer.write(' ');
		writer.write(Long.toString(this.getExecutionTime()));
		writer.newLine();
	}

	protected void read(BufferedReader reader) throws IOException {
		String[] line = reader.readLine().split(" ");
		this.taskSimpleName = line[0];
		this.executionTime = Integer.parseInt(line[1]);
	}
	
}
