package fr.inria.gforge.dspace.overlay.benchmarks.measurement;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Laurent Pellegrino
 *
 * @version $Id: TasksTimeMeasurementResults.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class TasksTimeMeasurementResults extends AbstractMeasurementResults {

	private List<TaskTimeMeasurementResults> measurementsResults;
	
	public TasksTimeMeasurementResults() {
		super();
	}
	
	public TasksTimeMeasurementResults(String associatedTaskSimpleName) {
		super(associatedTaskSimpleName);
	}
	
	public TasksTimeMeasurementResults(List<TaskTimeMeasurementResults> tasksTimeMeasurementResults) {
		this.measurementsResults = tasksTimeMeasurementResults;
	}

	public List<TaskTimeMeasurementResults> getMeasurementsResults() {
		return this.measurementsResults;
	}

	protected void write(BufferedWriter writer) throws IOException {
		for (TaskTimeMeasurementResults result: this.measurementsResults) {
			result.write(writer);
		}
	}

	protected void read(BufferedReader reader) throws IOException {
		String line;
		this.measurementsResults = new ArrayList<TaskTimeMeasurementResults>();
		TaskTimeMeasurementResults result;
		
		while (!(line = reader.readLine()).equals("")) {
			result = new TaskTimeMeasurementResults();
			result.read(new BufferedReader(new StringReader(line)));
			this.measurementsResults.add(result);
		}
	}
	
}
