package fr.inria.gforge.dspace.overlay.benchmarks.space;

import java.io.File;
import java.util.ArrayList;

import org.objectweb.proactive.core.node.Node;
import org.ontoware.rdf2go.model.Statement;

import fr.inria.gforge.dspace.overlay.benchmarks.tasks.AbstractTask;
import fr.inria.gforge.dspace.overlay.benchmarks.tasks.space.SetUpNetworkOnMultipleMachineTask;
import fr.inria.gforge.dspace.overlay.benchmarks.tasks.space.TearDownNetworkTask;

/**
 * Performs benchmarks on the space architecture. A space architecture is
 * represented by a CAN network. For these benchmarks, the active objects are
 * distributed among several {@link Node} using a GCMA descriptor file.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: SpaceNetworkBenchmarksDistributed.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class SpaceNetworkBenchmarksDistributed extends AbstractSpaceNetworkBenchmarks {

    private File pathToGCMA;
    
    private String pathToRdfFileToLoad;
    
    public SpaceNetworkBenchmarksDistributed(File pathToGCMA, int nbPeersCAN) {
        this(pathToGCMA, nbPeersCAN, 1000);
    }
    
    public SpaceNetworkBenchmarksDistributed(File pathToGCMA, int nbPeersCAN, int nbStatementsToAdd) {
        super(nbPeersCAN, nbStatementsToAdd);
        this.pathToGCMA = pathToGCMA;
    }
    
    public SpaceNetworkBenchmarksDistributed(File pathToGCMA, int nbPeersCAN, String pathToRdfFileToLoad) {
        this(pathToGCMA, nbPeersCAN);
        this.pathToRdfFileToLoad = pathToRdfFileToLoad;
        this.parseRdfFile();
        
        // TODO set super.nbStatementsToAdd ...
    }

    private void parseRdfFile() {
        this.statementsToAdd = new ArrayList<Statement>(1000);
        
        // TODO
        System.err.println("Not yet implemented");
        System.exit(1);
    }
   
	protected AbstractTask getTaskToExecuteForSetUp() {
		return new SetUpNetworkOnMultipleMachineTask(this, this.nbPeers, this.pathToGCMA);
	}

	protected AbstractTask getTaskToExecuteForTearDown() {
		return new TearDownNetworkTask(this);
	}
    
}
