package fr.inria.gforge.dspace.overlay.benchmarks.space;

import fr.inria.gforge.dspace.overlay.benchmarks.tasks.AbstractTask;
import fr.inria.gforge.dspace.overlay.benchmarks.tasks.space.SetUpNetworkOnLocalMachineTask;
import fr.inria.gforge.dspace.overlay.benchmarks.tasks.space.TearDownNetworkTask;

/**
 * Performs benchmarks on the space architecture. A space architecture is
 * represented by a CAN network.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: SpaceNetworkBenchmarksSingleMachine.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class SpaceNetworkBenchmarksSingleMachine extends AbstractSpaceNetworkBenchmarks {

    public SpaceNetworkBenchmarksSingleMachine(int nbPeers, int nbStatementsToAdd) {
        super(nbPeers, nbStatementsToAdd);
    }
    
    public void setUpNetwork() {
        super.initializer.setUpNetworkOnLocalMachine(super.nbPeers);
    }

    public void tearDownNetwork() {
        super.initializer.tearDownNetwork();
    }

	public AbstractTask getTaskToExecuteForSetUp() {
		return new SetUpNetworkOnLocalMachineTask(this, super.nbPeers);
	}

	public AbstractTask getTaskToExecuteForTearDown() {
		return new TearDownNetworkTask(this);
	}

	public static void main(String[] args) {
		SpaceNetworkBenchmarksSingleMachine bench = new SpaceNetworkBenchmarksSingleMachine(10, 1000);
		bench.run(true);
	}

}
