package fr.inria.gforge.dspace.overlay.benchmarks.tasks.space;

import java.util.Map;
import java.util.Map.Entry;
import java.util.UUID;

import org.objectweb.proactive.api.PAFuture;

import fr.inria.gforge.dspace.overlay.benchmarks.measurement.PeerMeasurementResults;
import fr.inria.gforge.dspace.overlay.benchmarks.measurement.PeersMeasurementResults;
import fr.inria.gforge.dspace.overlay.benchmarks.space.AbstractSpaceNetworkBenchmarks;
import fr.inria.gforge.dspace.overlay.benchmarks.tasks.AbstractTask;
import fr.inria.gforge.dspace.overlay.messages.query.can.StatementsCounterQueryMessage;
import fr.inria.gforge.dspace.overlay.messages.response.can.StatementsCounterResponseMessage;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: GetNbStatementsByPeerTask.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class GetNbStatementsByPeerTask extends AbstractTask {

	private PeersMeasurementResults peersMeasurementResults;
	
	public GetNbStatementsByPeerTask(AbstractSpaceNetworkBenchmarks benchmark) {
		super(benchmark);
	}

	public void run() {
		Map<UUID, Integer> result = 
	    	   ((StatementsCounterResponseMessage) PAFuture.getFutureValue(
	               super.benchmark.getRandomPeer().send(
	                       new StatementsCounterQueryMessage(
	                    		   super.benchmark.getSpaceNetworkInitializer().getSpaceURI())))).
	                    		   		mergeAndGetDataRetrieved();
		
		this.peersMeasurementResults = new PeersMeasurementResults(this.getClass().getSimpleName());
		for (Entry<UUID, Integer> entry : result.entrySet()) {
			this.peersMeasurementResults.getMeasurementsResults().add(
					new PeerMeasurementResults(
							entry.getKey(), entry.getValue()));
		}
	
		super.benchmark.add(this.peersMeasurementResults);
	}
	
}
