package fr.inria.gforge.dspace.overlay.benchmarks.tasks.space;

import org.objectweb.proactive.api.PAFuture;
import org.objectweb.proactive.extensions.structuredp2p.exceptions.DispatchException;

import fr.inria.gforge.dspace.overlay.api.messages.query.ConstructQuery;
import fr.inria.gforge.dspace.overlay.api.messages.response.ConstructResponse;
import fr.inria.gforge.dspace.overlay.benchmarks.measurement.QueryMeasurementResults;
import fr.inria.gforge.dspace.overlay.benchmarks.space.AbstractSpaceNetworkBenchmarks;
import fr.inria.gforge.dspace.overlay.benchmarks.tasks.AbstractTask;
import fr.inria.gforge.dspace.overlay.util.SemanticHelper;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: QueryAllTask.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class QueryAllTask extends AbstractTask {

	public QueryAllTask(AbstractSpaceNetworkBenchmarks benchmark) {
		super(benchmark);
	}
	
	public void run() {
		try {
			ConstructResponse response = (ConstructResponse) PAFuture.getFutureValue(
					super.benchmark.getRandomPeer().send(
							new ConstructQuery(
								super.benchmark.getSpaceNetworkInitializer().getSpaceURI(),
								"CONSTRUCT { ?s ?p ?o } WHERE  { ?s ?p ?o }")));
			
			super.benchmark.add(
					new QueryMeasurementResults(
							this.getClass().getSimpleName(),
							response.getNbStepsForSingleTrip(),
							response.getNbStepsForReturnTrip(),
							response.getLatency(),
							SemanticHelper.size(response.getResult())));
		} catch (DispatchException e) {
			e.printStackTrace();
		}
	}

}
