package fr.inria.gforge.dspace.overlay.benchmarks.tasks.space;

import org.objectweb.proactive.api.PAFuture;

import fr.inria.gforge.dspace.overlay.benchmarks.space.AbstractSpaceNetworkBenchmarks;
import fr.inria.gforge.dspace.overlay.benchmarks.tasks.AbstractTask;
import fr.inria.gforge.dspace.overlay.messages.query.can.RemoveStatementsQueryMessage;
import fr.inria.gforge.dspace.overlay.util.RDF2GoBuilder;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: RemoveAllStatementsTask.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class RemoveAllStatementsTask extends AbstractTask {

	public RemoveAllStatementsTask(AbstractSpaceNetworkBenchmarks benchmark) {
		super(benchmark);
	}

	public void run() {
		PAFuture.waitFor(super.benchmark.getRandomPeer().send(
				new RemoveStatementsQueryMessage(
						super.benchmark.getSpaceNetworkInitializer().getSpaceURI(), 
						RDF2GoBuilder.createStatement(null, null, null))));		
	}
	
}
