package fr.inria.gforge.dspace.overlay.benchmarks.tasks.space.bsbm;

import org.objectweb.proactive.api.PAFuture;
import org.objectweb.proactive.extensions.structuredp2p.exceptions.DispatchException;

import fr.inria.gforge.dspace.overlay.api.messages.query.ConstructQuery;
import fr.inria.gforge.dspace.overlay.api.messages.response.ConstructResponse;
import fr.inria.gforge.dspace.overlay.benchmarks.space.AbstractSpaceNetworkBenchmarks;

/**
 * Query consists in retrieving all data where producers are from DE.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: BSBMCustomQuery1Task.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class BSBMCustomQuery1Task extends BSBMQueryTask {

	public BSBMCustomQuery1Task(AbstractSpaceNetworkBenchmarks benchmark) {
		super(benchmark);
	}
	
	public BSBMCustomQuery1Task(AbstractSpaceNetworkBenchmarks benchmark, boolean storeMeasurementResult) {
		super(benchmark, storeMeasurementResult);
	}
	
	public void run() {
		try {
			ConstructResponse response = (ConstructResponse) PAFuture.getFutureValue(
					super.benchmark.getRandomPeer().send(
							new ConstructQuery(
									super.benchmark.getSpaceNetworkInitializer().getSpaceURI(),
									"CONSTRUCT { <http://downlode.org/rdf/iso-3166/countries#DE> <http://www.ecommerce.com/Producers> ?producer } WHERE { ?producer <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> <http://www4.wiwiss.fu-berlin.de/bizer/bsbm/v01/vocabulary/Producer> . ?producer <http://www4.wiwiss.fu-berlin.de/bizer/bsbm/v01/vocabulary/country> <http://downlode.org/rdf/iso-3166/countries#DE> }")));
			super.addQueryMeasurementResult(response);
		} catch (DispatchException e) {
			e.printStackTrace();
		}
	}

}
