package fr.inria.gforge.dspace.overlay.benchmarks.tasks.space.bsbm;

import org.objectweb.proactive.api.PAFuture;
import org.objectweb.proactive.extensions.structuredp2p.exceptions.DispatchException;

import fr.inria.gforge.dspace.overlay.api.messages.query.ConstructQuery;
import fr.inria.gforge.dspace.overlay.api.messages.response.ConstructResponse;
import fr.inria.gforge.dspace.overlay.benchmarks.space.AbstractSpaceNetworkBenchmarks;

/**
 * Query consists in retrieving all instances of Review.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: BSBMCustomQuery2Task.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class BSBMCustomQuery2Task extends BSBMQueryTask {

	public BSBMCustomQuery2Task(AbstractSpaceNetworkBenchmarks benchmark) {
		super(benchmark);
	}
	
	public BSBMCustomQuery2Task(AbstractSpaceNetworkBenchmarks benchmark, boolean storeMeasurementResult) {
		super(benchmark, storeMeasurementResult);
	}
	
	public void run() {
		try {
			ConstructResponse response = (ConstructResponse) PAFuture.getFutureValue(
					super.benchmark.getRandomPeer().send(
							new ConstructQuery(
									super.benchmark.getSpaceNetworkInitializer().getSpaceURI(),
									"CONSTRUCT { ?review <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> <http://purl.org/stuff/rev#Review> } WHERE { ?review <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> <http://purl.org/stuff/rev#Review> }")));
			super.addQueryMeasurementResult(response);
		} catch (DispatchException e) {
			e.printStackTrace();
		}
	}

}
