package fr.inria.gforge.dspace.overlay.benchmarks.tasks.space.bsbm;

import org.objectweb.proactive.api.PAFuture;
import org.objectweb.proactive.extensions.structuredp2p.exceptions.DispatchException;

import fr.inria.gforge.dspace.overlay.api.messages.query.ConstructQuery;
import fr.inria.gforge.dspace.overlay.api.messages.response.ConstructResponse;
import fr.inria.gforge.dspace.overlay.benchmarks.space.AbstractSpaceNetworkBenchmarks;

/**
 * Query consist in retrieving all data which imply a type relation as
 * predicate.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: BSBMCustomQuery3Task.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class BSBMCustomQuery3Task extends BSBMQueryTask {

	public BSBMCustomQuery3Task(AbstractSpaceNetworkBenchmarks benchmark) {
		super(benchmark);
	}
	
	public BSBMCustomQuery3Task(AbstractSpaceNetworkBenchmarks benchmark, boolean storeMeasurementResult) {
		super(benchmark, storeMeasurementResult);
	}
	
	public void run() {
		try {
			ConstructResponse response = (ConstructResponse) PAFuture.getFutureValue(
					super.benchmark.getRandomPeer().send(
							new ConstructQuery(
									super.benchmark.getSpaceNetworkInitializer().getSpaceURI(),
									"CONSTRUCT { ?s <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> ?o } WHERE { ?s <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> ?o }")));
			super.addQueryMeasurementResult(response);
		} catch (DispatchException e) {
			e.printStackTrace();
		}
	}

}
