package fr.inria.gforge.dspace.overlay.benchmarks.tasks.space.bsbm;

import org.objectweb.proactive.api.PAFuture;
import org.objectweb.proactive.extensions.structuredp2p.exceptions.DispatchException;

import fr.inria.gforge.dspace.overlay.api.messages.query.ConstructQuery;
import fr.inria.gforge.dspace.overlay.api.messages.response.ConstructResponse;
import fr.inria.gforge.dspace.overlay.benchmarks.space.AbstractSpaceNetworkBenchmarks;

/**
 * Query consist in retrieving all data where
 * http://www4.wiwiss.fu-berlin.de/bizer/bsbm/v01/instances/ProductType1
 * instance appears.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: BSBMCustomQuery4Task.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class BSBMCustomQuery4Task extends BSBMQueryTask {

	public BSBMCustomQuery4Task(AbstractSpaceNetworkBenchmarks benchmark) {
		super(benchmark);
	}
	
	public BSBMCustomQuery4Task(AbstractSpaceNetworkBenchmarks benchmark, boolean storeMeasurementResult) {
		super(benchmark, storeMeasurementResult);
	}
	
	public void run() {
		try {
			ConstructResponse response = (ConstructResponse) PAFuture.getFutureValue(
					super.benchmark.getRandomPeer().send(
							new ConstructQuery(
									super.benchmark.getSpaceNetworkInitializer().getSpaceURI(),
									"CONSTRUCT { <http://www4.wiwiss.fu-berlin.de/bizer/bsbm/v01/instances/ProductType1> ?a ?b . ?c ?d <http://www4.wiwiss.fu-berlin.de/bizer/bsbm/v01/instances/ProductType1> } WHERE { <http://www4.wiwiss.fu-berlin.de/bizer/bsbm/v01/instances/ProductType1> ?a ?b . ?c ?d <http://www4.wiwiss.fu-berlin.de/bizer/bsbm/v01/instances/ProductType1> }")));
			super.addQueryMeasurementResult(response);
		} catch (DispatchException e) {
			e.printStackTrace();
		}
	}

}
