package fr.inria.gforge.dspace.overlay.benchmarks.tasks.space.bsbm;

import org.ontoware.aifbcommons.collection.ClosableIterable;

import fr.inria.gforge.dspace.overlay.api.messages.response.SPARQLResponse;
import fr.inria.gforge.dspace.overlay.benchmarks.measurement.QueryMeasurementResults;
import fr.inria.gforge.dspace.overlay.benchmarks.space.AbstractSpaceNetworkBenchmarks;
import fr.inria.gforge.dspace.overlay.benchmarks.tasks.AbstractTask;
import fr.inria.gforge.dspace.overlay.util.SemanticHelper;

/**
 * @author Laurent Pellegrino
 *
 * @version $Id: BSBMQueryTask.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public abstract class BSBMQueryTask extends AbstractTask {

	private boolean storeMeasurementResult = true;
	
	public BSBMQueryTask(AbstractSpaceNetworkBenchmarks benchmark) {
		super(benchmark);
	}
	
	public BSBMQueryTask(AbstractSpaceNetworkBenchmarks benchmark, boolean storeMeasurementResult) {
		super(benchmark);
		this.storeMeasurementResult = storeMeasurementResult;
	}
	
	public void addQueryMeasurementResult(SPARQLResponse<?> response) {
		if (this.storeMeasurementResult) {
			super.benchmark.add(
					new QueryMeasurementResults(
							this.getClass().getSimpleName(),
							response.getNbStepsForSingleTrip(),
							response.getNbStepsForReturnTrip(),
							response.getLatency(),
							SemanticHelper.size((ClosableIterable<?>) response.getResult())));
		}
	}

}
