package fr.inria.gforge.dspace.overlay.api.messages.query;

import org.ontoware.rdf2go.model.node.URI;

import fr.inria.gforge.dspace.overlay.messages.query.can.SemanticQueryMessage;
import fr.inria.gforge.dspace.overlay.messages.response.can.AnycastResponseMessage;
import fr.inria.gforge.dspace.overlay.messages.response.can.AskResponseMessage;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: AskQuery.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class AskQuery extends SPARQLQuery {

    private static final long serialVersionUID = 1L;

    public AskQuery(URI spaceURI, String queryAsString) {
        super(spaceURI, queryAsString);
    }

    public AnycastResponseMessage<?> createResponseMessage(
            SemanticQueryMessage query) {
        return new AskResponseMessage(query, query.getKeyToReach());
    }

}
