package fr.inria.gforge.dspace.overlay.api.messages.query;

import org.objectweb.proactive.extensions.structuredp2p.api.messages.Query;
import org.ontoware.rdf2go.model.node.URI;

import fr.inria.gforge.dspace.overlay.messages.query.can.SemanticQueryMessage;
import fr.inria.gforge.dspace.overlay.messages.response.can.AnycastResponseMessage;

/**
 * SPARQLQuery is an abstract class which contains information for all sparql
 * queries like {@link AskQuery}, {@link ConstructQuery} and {@link SelectQuery}
 * .
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: SPARQLQuery.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public abstract class SPARQLQuery implements Query {

    private static final long serialVersionUID = 1L;

    private String queryAsString;

    private URI spaceURI;

    public abstract AnycastResponseMessage<?> createResponseMessage(
            SemanticQueryMessage query);

    public SPARQLQuery(URI spaceURI, String queryAsString) {
        this.spaceURI = spaceURI;
        this.queryAsString = queryAsString;
    }

    public String toString() {
        return this.queryAsString;
    }

    public URI getSpaceURI() {
        return this.spaceURI;
    }

}
