package fr.inria.gforge.dspace.overlay.api.messages.response;

import java.util.HashSet;

import org.ontoware.aifbcommons.collection.ClosableIterable;
import org.ontoware.rdf2go.model.Statement;

import fr.inria.gforge.dspace.overlay.api.messages.query.ConstructQuery;
import fr.inria.gforge.dspace.overlay.messages.response.can.DescribeResponseMessage;
import fr.inria.gforge.dspace.overlay.rdf2go.wrappers.ClosableIterableWrapper;
import fr.inria.gforge.dspace.overlay.util.SemanticHelper;

/**
 * Associated response for {@link ConstructQuery}.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: DescribeResponse.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class DescribeResponse extends
        SPARQLResponse<ClosableIterable<Statement>> {

    private static final long serialVersionUID = 1L;
    
    public DescribeResponse(DescribeResponseMessage describeQueryResponseMessage) {
        super(SemanticHelper.generateClosableIterable(new HashSet<Statement>()),
              describeQueryResponseMessage.getOutboundHopCount(),
              describeQueryResponseMessage.getReturnHopCount(),
              describeQueryResponseMessage.getLatency());

        ClosableIterableWrapper dataRetrieved = describeQueryResponseMessage.mergeAndGetDataRetrieved();
        if (dataRetrieved != null) {
            this.result = dataRetrieved.toRDF2Go();
        }
    }

}
