package fr.inria.gforge.dspace.overlay.api.messages.response;

import org.objectweb.proactive.extensions.structuredp2p.api.messages.Response;

import fr.inria.gforge.dspace.overlay.messages.response.can.ConstructResponseMessage;

/**
 * SparqlQueryResponse is an abstract class which contains information about
 * sparql responses like {@link AskResponse},
 * {@link ConstructResponseMessage} and {@link SelectResponse}.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: SPARQLResponse.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public abstract class SPARQLResponse<T> implements Response {

    private static final long serialVersionUID = 1L;
    
    protected T result;

    private int nbStepsForSingleTrip;
    
    private int nbStepsForReturnTrip;
    
    private int latency;
    
    public SPARQLResponse() {
        
    }
    
    public SPARQLResponse(T result, int nbStepsForSingleTrip, int nbStepsForReturnTrip, int latency) {
        this.result = result;
        this.nbStepsForSingleTrip = nbStepsForSingleTrip;
        this.nbStepsForReturnTrip = nbStepsForReturnTrip;
        this.latency = latency;
    }

    public int getLatency() {
        return this.latency;
    }

    public int getNbStepsForSingleTrip() {
        return nbStepsForSingleTrip;
    }

    public int getNbStepsForReturnTrip() {
        return nbStepsForReturnTrip;
    }

    public T getResult() {
        return this.result;
    }

}
