package fr.inria.gforge.dspace.overlay.api.messages.response;

import java.util.ArrayList;
import java.util.HashSet;

import org.ontoware.rdf2go.model.QueryResultTable;
import org.ontoware.rdf2go.model.QueryRow;

import fr.inria.gforge.dspace.overlay.api.messages.query.SelectQuery;
import fr.inria.gforge.dspace.overlay.messages.response.can.SelectResponseMessage;
import fr.inria.gforge.dspace.overlay.rdf2go.wrappers.QueryResultTableWrapper;
import fr.inria.gforge.dspace.overlay.util.SemanticHelper;

/**
 * Associated response for {@link SelectQuery}.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: SelectResponse.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class SelectResponse extends
        SPARQLResponse<QueryResultTable> {

    private static final long serialVersionUID = 1L;

    public SelectResponse(SelectResponseMessage response) {
        super(SemanticHelper.generateQueryResultTable(new ArrayList<String>(), new HashSet<QueryRow>()),
              response.getOutboundHopCount(),
              response.getReturnHopCount(),
              response.getLatency());
        
        QueryResultTableWrapper dataRetrieved = response.mergeAndGetDataRetrieved();
        if (dataRetrieved != null) {
            this.result = dataRetrieved.toRDF2Go();
        }
    }
    
}
