package fr.inria.gforge.dspace.overlay.deployment;

import java.util.List;

import org.objectweb.proactive.core.node.Node;

/**
 * Stores {@link Node}s acquired for a {@link NodeProviderKey}.
 * 
 * @author Laurent Pellegrino
 *
 * @version $Id: NodeProviderEntry.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class NodeProviderEntry {

    private int index;
    
    private List<Node> nodes;
    
    public NodeProviderEntry(List<Node> nodes) {
        this.nodes = nodes;
    }
    
    public Node getNextNode() {
        if (this.index > this.nodes.size() - 1) {
            this.index = 0;
        }

        return this.nodes.get(this.index++);
    }

    public List<Node> getNodes() {
        return this.nodes;
    }
    
}
