package fr.inria.gforge.dspace.overlay.initializers;

import org.objectweb.proactive.core.util.ProActiveRandom;

/**
 * Defines and store many informations which are commons to all network
 * initializers.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: SemanticNetworkInitializer.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public abstract class SemanticNetworkInitializer<T> {

    protected boolean initialized = false;

    protected T[] trackers;

    public SemanticNetworkInitializer() {

    }
    
    public abstract void tearDownNetwork();

    public T getRandomTracker() {
        return this.trackers[ProActiveRandom.nextInt(this.trackers.length)];
    }

    public T[] getTrackers() {
        return this.trackers;
    }

}
