package fr.inria.gforge.dspace.overlay.kernel.operations.datastore;

import org.ontoware.rdf2go.model.node.URI;

import at.sti2.semanticspaces.api.exceptions.SemanticSpaceException;
import fr.inria.gforge.dspace.overlay.datastore.SemanticDataStore;

/**
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: HasStatementsOperation.java 3127 2010-01-06 15:59:42Z laurentp
 *          $
 */
@SuppressWarnings("serial")
public class HasStatementsOperation extends AbstractDatastoreOperation {

    public HasStatementsOperation(URI spaceURI) {
        super(spaceURI);
    }

    public DatastoreResponseOperation<Boolean> handle(SemanticDataStore dataStore) {
        try {
            return new DatastoreResponseOperation<Boolean>(dataStore.sparqlAsk(super.spaceURI,
                    "ASK { GRAPH<" + super.spaceURI + "> { ?s ?p ?o } . }"));
        } catch (SemanticSpaceException e) {
            e.printStackTrace();
            return new DatastoreResponseOperation<Boolean>(false);
        } catch (Exception e) {
            e.printStackTrace();
            return new DatastoreResponseOperation<Boolean>(false);
        }
    }

}
