package fr.inria.gforge.dspace.overlay.kernel.operations.datastore;

import org.ontoware.rdf2go.model.node.URI;

import at.sti2.semanticspaces.api.exceptions.SemanticSpaceException;
import fr.inria.gforge.dspace.overlay.datastore.SemanticDataStore;

/**
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: SPARQLAskOperation.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class SPARQLAskOperation extends AbstractDatastoreOperation {

    private static final long serialVersionUID = 1L;

    private String query;

    public SPARQLAskOperation(URI spaceURI, String query) {
        super(spaceURI);
        this.query = query;
    }

    public DatastoreResponseOperation<Boolean> handle(SemanticDataStore dataStore)
            throws SemanticSpaceException {
        return new DatastoreResponseOperation<Boolean>(
        		dataStore.sparqlAsk(super.spaceURI, this.query));
    }

}