package fr.inria.gforge.dspace.overlay.kernel.operations.datastore;

import org.ontoware.rdf2go.model.node.URI;

import at.sti2.semanticspaces.api.exceptions.SemanticSpaceException;
import fr.inria.gforge.dspace.overlay.datastore.SemanticDataStore;
import fr.inria.gforge.dspace.overlay.rdf2go.wrappers.ClosableIterableWrapper;

/**
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: SPARQLDescribeOperation.java 3622 2010-03-12 09:15:46Z
 *          laurentp $
 */
public class SPARQLDescribeOperation extends AbstractDatastoreOperation {

    private static final long serialVersionUID = 1L;
    
    private String query;

    public SPARQLDescribeOperation(URI spaceURI, String query) {
        super(spaceURI);
        this.query = query;
    }

    public DatastoreResponseOperation<ClosableIterableWrapper> handle(SemanticDataStore dataStore)
            throws SemanticSpaceException {
        return new DatastoreResponseOperation<ClosableIterableWrapper>(
                    new ClosableIterableWrapper(
                        dataStore.sparqlDescribe(super.spaceURI, this.query)));
    }

}