package fr.inria.gforge.dspace.overlay.kernel.operations.datastore;

import org.ontoware.rdf2go.model.node.URI;

import at.sti2.semanticspaces.api.exceptions.SemanticSpaceException;
import fr.inria.gforge.dspace.overlay.datastore.SemanticDataStore;
import fr.inria.gforge.dspace.overlay.rdf2go.wrappers.QueryResultTableWrapper;

/**
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: SPARQLSelectOperation.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class SPARQLSelectOperation extends AbstractDatastoreOperation {

    private static final long serialVersionUID = 1L;
    
    private String query;

    public SPARQLSelectOperation(URI spaceURI, String query) {
        super(spaceURI);
        this.query = query;
    }

    public DatastoreResponseOperation<QueryResultTableWrapper> handle(SemanticDataStore dataStore)
            throws SemanticSpaceException {
        return new DatastoreResponseOperation<QueryResultTableWrapper>(
        	new QueryResultTableWrapper(
        		dataStore.sparqlSelect(super.spaceURI, this.query)));
    }

}