package fr.inria.gforge.dspace.overlay.messages;

import java.io.Serializable;


/**
 * Represents an {@link Object} as an array of bytes.
 *
 * @author Laurent Pellegrino
 * 
 * @version $Id: ObjectAsByteArray.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class ObjectAsByteArray implements Serializable {
    
    private static final long serialVersionUID = 1L;
  
    private byte[] bytes; 

    /**
     * Constructor.
     */
    public ObjectAsByteArray(byte[] b) {
        this.bytes = b;
    }

    /**
     * Returns the internal byte array. Note that this is a live
     * reference to the actual data, not a copy.
     */
    public byte[] getBytes() {
        return this.bytes;
    }

}