package fr.inria.gforge.dspace.overlay.messages.query.can;

import java.io.Serializable;
import java.util.UUID;

import org.objectweb.proactive.extensions.structuredp2p.overlay.Peer;

/**
 * Contains information about {@link Peer}s met while routing an {@link AnycastQueryMessage}. 
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: AnycastRoutingEntry.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class AnycastRoutingEntry implements Serializable {

    private static final long serialVersionUID = 1L;

    private UUID peerID;

    private Peer peerStub;

    private boolean validatesKeyConstraints = false;

    public UUID getPeerID() {
        return this.peerID;
    }

    public AnycastRoutingEntry(UUID peerID, Peer peerStub, boolean validKeyConstraints) {
        super();
        this.peerID = peerID;
        this.peerStub = peerStub;
        this.validatesKeyConstraints = validKeyConstraints;
    }

    public Peer getPeerStub() {
        return this.peerStub;
    }

    public boolean validatesKeyConstraints() {
        return this.validatesKeyConstraints;
    }

}
