package fr.inria.gforge.dspace.overlay.messages.query.chord;

import org.objectweb.proactive.extensions.structuredp2p.messages.query.chord.TurnAroundQueryMessage;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.AbstractChordOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Entry;
import org.ontoware.rdf2go.model.node.URI;

import fr.inria.gforge.dspace.overlay.overlay.chord.SemanticResource;

/**
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: ListSpacesQueryMessage.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class ListSpacesQueryMessage extends TurnAroundQueryMessage<URI> {

    private static final long serialVersionUID = 1L;

    @SuppressWarnings("unchecked")
    public void updateValues(StructuredOverlay overlay) {
        for (Entry<SemanticResource> entry : 
            ((AbstractChordOverlay<SemanticResource>) overlay).getEntries()) {
            super.values.add(entry.getValue().getSpaceURI());
        }
    }

}
