package fr.inria.gforge.dspace.overlay.messages.query.chord;

import org.objectweb.proactive.extensions.structuredp2p.exceptions.NetworkNotJoinedException;
import org.objectweb.proactive.extensions.structuredp2p.messages.query.chord.FingerQueryMessage;
import org.objectweb.proactive.extensions.structuredp2p.overlay.Peer;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Entry;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Key;
import org.ontoware.rdf2go.model.node.URI;

import fr.inria.gforge.dspace.overlay.overlay.chord.SemanticResource;
import fr.inria.gforge.dspace.overlay.overlay.chord.SemanticSpaceChordOverlay;

/**
 * Removes a {@link Peer} of type CAN on the specified spaceURI.
 * 
 * @version $Id: RemovePeerOnCANQueryMessage.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class RemovePeerOnCANQueryMessage extends FingerQueryMessage {

    private static final long serialVersionUID = 1L;

    public RemovePeerOnCANQueryMessage(URI spaceURI) {
        super(new Key(spaceURI.toString()));
    }

    public void onDestinationReached(StructuredOverlay overlay) {
        Entry<SemanticResource> entry;
        if ((entry = ((SemanticSpaceChordOverlay) overlay).getEntry(super.getKeyToReach())) != null) {
            try {
                entry.getValue().removeRandomPeer().leave();
            } catch (NetworkNotJoinedException e) {
                e.printStackTrace();
            }
        }
    }

}
