package fr.inria.gforge.dspace.overlay.messages.query.chord;

import org.objectweb.proactive.extensions.structuredp2p.messages.query.chord.FingerQueryMessage;
import org.objectweb.proactive.extensions.structuredp2p.messages.response.chord.FingerResponseMessage;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Key;
import org.ontoware.rdf2go.model.node.URI;

import fr.inria.gforge.dspace.overlay.messages.response.chord.SpaceExistsResponseMessage;
import fr.inria.gforge.dspace.overlay.overlay.chord.SemanticSpaceChordOverlay;

/**
 * Perform a lookup in order to check if the specified space already exists on
 * the network.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: SpaceExistsQueryMessage.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class SpaceExistsQueryMessage extends FingerQueryMessage {

    private static final long serialVersionUID = 1L;
    
    private boolean spaceExists = false;

    public SpaceExistsQueryMessage(URI spaceURI) {
        super(new Key(spaceURI.toString()));
    }

    public void onDestinationReached(StructuredOverlay overlay) {
        if (((SemanticSpaceChordOverlay) overlay).getEntry(super.getKeyToReach()) != null) {
            this.spaceExists = true;
        }
    }

    public FingerResponseMessage createResponseMessage() {
        return new SpaceExistsResponseMessage(this, super.senderKey, this.spaceExists);
    }

}
