package fr.inria.gforge.dspace.overlay.messages.response.can;

import org.objectweb.proactive.extensions.structuredp2p.api.messages.Response;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.can.coordinates.CoordinateValue;

import fr.inria.gforge.dspace.overlay.messages.query.can.RemoveStatementsQueryMessage;
import fr.inria.gforge.dspace.overlay.router.can.AnycastResponseRouter;

/**
 * Indicates if a {@link RemoveStatementsQueryMessage} has succeeded or not.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: RemoveStatementsResponseMessage.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class RemoveStatementsResponseMessage extends AnycastResponseMessage<Boolean> {

    private static final long serialVersionUID = 1L;

    public RemoveStatementsResponseMessage(RemoveStatementsQueryMessage query,
            CoordinateValue[] coordinatesToReach, Boolean result) {
        super(query, coordinatesToReach);
        super.storeData(result);
    }

    public RemoveStatementsResponseMessage(RemoveStatementsQueryMessage query,
            CoordinateValue[] coordinatesToReach) {
        super(query, coordinatesToReach);
    }

    public Boolean merge(Boolean data1, Boolean data2) {
        return data1 || data2;
    }

    public Boolean queryDataStore(StructuredOverlay overlay) {
        return null;
    }

    public AnycastResponseRouter<? extends AnycastResponseMessage<Boolean>, Boolean> getRouter() {
        return new AnycastResponseRouter<AnycastResponseMessage<Boolean>, Boolean>(null);
    }

    /**
     * Not used because this message is never called from the public API.
     */
    public Response createResponse() {
        return null;
    }

}
