package fr.inria.gforge.dspace.overlay.messages.response.can;

import org.objectweb.proactive.extensions.structuredp2p.overlay.can.coordinates.CoordinateValue;

import fr.inria.gforge.dspace.overlay.api.messages.query.SPARQLQuery;
import fr.inria.gforge.dspace.overlay.messages.query.can.SemanticQueryMessage;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: SemanticResponseMessage.java 4272 2010-04-26 14:31:05Z
 *          laurentp $
 */
public abstract class SemanticResponseMessage<T> extends AnycastResponseMessage<T> {

    private static final long serialVersionUID = 1L;

    private SPARQLQuery sparqlQuery;

    public SemanticResponseMessage(
            SemanticResponseMessage<?> response,
            CoordinateValue[] coordinatesToReach) {
        super(response, coordinatesToReach);
        this.sparqlQuery = response.getSparqlQuery();
    }

    public SemanticResponseMessage(
            SemanticQueryMessage query,
            CoordinateValue[] coordinatesToReach) {
        super(query, coordinatesToReach);
        this.sparqlQuery = query.getSparqlQuery();
    }

    /**
     * Returns the {@link SPARQLQuery} which is being handled.
     * 
     * @return the {@link SPARQLQuery} which is being handled.
     */
    public SPARQLQuery getSparqlQuery() {
        return this.sparqlQuery;
    }

}
