package fr.inria.gforge.dspace.overlay.messages.response.can;

import java.util.Map;
import java.util.UUID;

import org.objectweb.proactive.extensions.structuredp2p.api.messages.Response;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.can.coordinates.CoordinateValue;

import fr.inria.gforge.dspace.overlay.messages.query.can.StatementsCounterQueryMessage;
import fr.inria.gforge.dspace.overlay.router.can.AnycastResponseRouter;

/**
 * Response associated to {@link StatementsCounterQueryMessage}.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: StatementsCounterResponseMessage.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class StatementsCounterResponseMessage extends AnycastResponseMessage<Map<UUID, Integer>> {

    private static final long serialVersionUID = 1L;

    public StatementsCounterResponseMessage(StatementsCounterQueryMessage query,
            CoordinateValue[] coordinatesToReach, Map<UUID, Integer> result) {
        super(query, coordinatesToReach);
        super.storeData(result);
    }

    public StatementsCounterResponseMessage(StatementsCounterQueryMessage query,
            CoordinateValue[] coordinatesToReach) {
        super(query, coordinatesToReach);
    }

    public Map<UUID, Integer> merge(Map<UUID, Integer> data1, Map<UUID, Integer> data2) {
        if (data2 == null) {
        	return data1;
        } else {
            data1.putAll(data2);
            return data1;
        }
    }

    public Map<UUID, Integer> queryDataStore(StructuredOverlay overlay) {
        return null;
    }

    public AnycastResponseRouter<? extends AnycastResponseMessage<Map<UUID, Integer>>, Map<UUID, Integer>> getRouter() {
        return new AnycastResponseRouter<AnycastResponseMessage<Map<UUID, Integer>>, Map<UUID, Integer>>(null);
    }

    /**
     * Not used because this message is never called from the public API.
     */
    public Response createResponse() {
        return null;
    }

}
