package fr.inria.gforge.dspace.overlay.messages.response.chord;

import org.objectweb.proactive.extensions.structuredp2p.messages.query.chord.FingerQueryMessage;
import org.objectweb.proactive.extensions.structuredp2p.messages.response.chord.FingerResponseMessage;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Key;

import fr.inria.gforge.dspace.overlay.messages.query.chord.NbReferencesStoredQueryMessage;

/**
 * Response associated to {@link NbReferencesStoredQueryMessage}.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: NbReferencesStoredResponseMessage.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class NbReferencesStoredResponseMessage extends FingerResponseMessage {

    private static final long serialVersionUID = 1L;
    
    private int nbReferences;

    public NbReferencesStoredResponseMessage(FingerQueryMessage query, Key keyToReach, int nbReferences) {
        super(query, keyToReach);
        this.nbReferences = nbReferences;
    }

    public int getNbReferences() {
        return this.nbReferences;
    }

}
