package fr.inria.gforge.dspace.overlay.operations.can;

import org.objectweb.proactive.extensions.structuredp2p.operations.Operation;
import org.objectweb.proactive.extensions.structuredp2p.operations.ResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.Peer;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;

import fr.inria.gforge.dspace.overlay.kernel.SemanticSpaceOverlayKernel;
import fr.inria.gforge.dspace.overlay.overlay.can.SemanticSpaceCANOverlay;

/**
 * Message used to retrieve the {@link SemanticSpaceOverlayKernel} remote
 * reference from a targeted {@link Peer}.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: GetOverlayKernelOperation.java 3576 2010-03-04 15:20:20Z laurentp$
 */
public class GetOverlayKernelOperation implements Operation {

    private static final long serialVersionUID = 1L;

    public ResponseOperation handle(StructuredOverlay overlay) {
        return new GetOverlayKernelResponseOperation(
        	((SemanticSpaceCANOverlay) overlay).getRemoteSemanticSpaceOverlayKernel());
    }

}
