package fr.inria.gforge.dspace.overlay.operations.can;

import java.util.UUID;

import org.objectweb.proactive.extensions.structuredp2p.operations.Operation;
import org.objectweb.proactive.extensions.structuredp2p.operations.ResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;

import fr.inria.gforge.dspace.overlay.overlay.can.SemanticSpaceCANOverlay;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: GetZoneInfoOperation.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class GetZoneInfoOperation implements Operation {

    private static final long serialVersionUID = 1L;
    
    private UUID synchronousMessageId;

    public GetZoneInfoOperation(UUID synchronousMessageId) {
        this.synchronousMessageId = synchronousMessageId;
    }

    public ResponseOperation handle(StructuredOverlay overlay) {
        return new GetZoneInfoResponseOperation(((SemanticSpaceCANOverlay) overlay).getZone(),
                ((SemanticSpaceCANOverlay) overlay).getQueryManager()
                        .getSynchronousMessagesIdentifiersMet().contains(this.synchronousMessageId));
    }

}
