package fr.inria.gforge.dspace.overlay.operations.chord;

import org.objectweb.proactive.extensions.structuredp2p.operations.Operation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Key;

import fr.inria.gforge.dspace.overlay.overlay.SemanticPeer;
import fr.inria.gforge.dspace.overlay.overlay.chord.SemanticSpaceChordOverlay;

/**
 * Retrieves a {@link SemanticPeer} for the specified {@link Key} or
 * <code>null</code> if no entry is found.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: GetRandomPeerOperation.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class GetRandomPeerOperation implements Operation {

    private static final long serialVersionUID = 1L;

    private Key keyToUse;

    /**
     * Constructor.
     * 
     * @param key
     *            the key associated to the entry to lookup.
     */
    public GetRandomPeerOperation(Key key) {
        this.keyToUse = key;
    }

    public GetRandomPeerResponseOperation handle(StructuredOverlay overlay) {
        return new GetRandomPeerResponseOperation(
                ((SemanticSpaceChordOverlay) overlay).getRandomPeer(this.keyToUse));
    }
    
}
