package fr.inria.gforge.dspace.overlay.operations.chord;

import org.objectweb.proactive.extensions.structuredp2p.operations.ResponseOperation;

import fr.inria.gforge.dspace.overlay.overlay.SemanticPeer;

/**
 * Response associated to a {@link GetRandomPeerOperation}.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: GetRandomPeerResponseOperation.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class GetRandomPeerResponseOperation implements ResponseOperation {

    private static final long serialVersionUID = 1L;

    private SemanticPeer remotePeer;

    public GetRandomPeerResponseOperation(SemanticPeer peer) {
        this.remotePeer = peer;
    }

    /**
     * Returns a {@link SemanticPeer} stub of type CAN or <code>null</code>.
     * 
     * @return a {@link SemanticPeer} stub of type CAN or <code>null</code>.
     */
    public SemanticPeer getRemotePeer() {
        return this.remotePeer;
    }

}
