package fr.inria.gforge.dspace.overlay.operations.chord;

import org.objectweb.proactive.extensions.structuredp2p.operations.Operation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Key;

import fr.inria.gforge.dspace.overlay.overlay.chord.SemanticResource;
import fr.inria.gforge.dspace.overlay.overlay.chord.SemanticSpaceChordOverlay;

/**
 * Retrieves a {@link SemanticResource} for the specified {@link Key} or
 * <code>null</code> if no entry is found.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: GetSemanticResourceOperation.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class GetSemanticResourceOperation implements Operation {

    private static final long serialVersionUID = 1L;

    private Key keyToUse;

    /**
     * Constructor.
     * 
     * @param key
     *            the key associated to the entry to lookup.
     */
    public GetSemanticResourceOperation(Key key) {
        this.keyToUse = key;
    }

    /**
     * {@inheritDoc}
     */
    public GetSemanticResourceResponseOperation handle(StructuredOverlay overlay) {
        return new GetSemanticResourceResponseOperation(
                ((SemanticSpaceChordOverlay) overlay).getSemanticResource(this.keyToUse));
    }
    
}
