package fr.inria.gforge.dspace.overlay.operations.chord;

import org.objectweb.proactive.extensions.structuredp2p.operations.ResponseOperation;

import fr.inria.gforge.dspace.overlay.overlay.chord.SemanticResource;

/**
 * Response associated to a {@link GetSemanticResourceResponseOperation}.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: GetSemanticResourceResponseOperation.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class GetSemanticResourceResponseOperation implements ResponseOperation {

    private static final long serialVersionUID = 1L;

    private SemanticResource resource;

    public GetSemanticResourceResponseOperation(SemanticResource resource) {
        this.resource = resource;
    }

    /**
     * Returns a {@link SemanticResource} or <code>null</code>.
     * 
     * @return a {@link SemanticResource} or <code>null</code>.
     */
    public SemanticResource getSemanticResource() {
        return this.resource;
    }

}
