package fr.inria.gforge.dspace.overlay.reasoner;


/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: DecomposedQueryMessageEntry.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class DecomposedQueryMessageEntry {

    public enum Status {
        ALL_RESPONSES_RECEIVED, RECEIPT_IN_PROGRESS
    };

    private Status status = Status.RECEIPT_IN_PROGRESS;

    private ParsedSPARQLQuery decomposedSparqlQuery;

    private int numberOfResponseWaiting = 0;

    private int numberOfResponseReceived = 0;

    public DecomposedQueryMessageEntry(ParsedSPARQLQuery decomposedSparqlQuery) {
        super();
        this.decomposedSparqlQuery = decomposedSparqlQuery;
        this.numberOfResponseWaiting = decomposedSparqlQuery.getSubQueries().size();
    }

    /**
     * @return the status
     */
    public Status getStatus() {
        return this.status;
    }

    /**
     * @return the response
     */
    public ParsedSPARQLQuery getDecomposedSparqlQuery() {
        return this.decomposedSparqlQuery;
    }

    /**
     * @return the numberOfResponseWaiting
     */
    public int getNumberOfResponseWaiting() {
        return this.numberOfResponseWaiting;
    }

    /**
     * @return the numberOfResponseReceived
     */
    public int getNumberOfResponseReceived() {
        return this.numberOfResponseReceived;
    }

    public void incrementNbResponseReceived(int increment) {
        this.numberOfResponseReceived++;
        if (this.numberOfResponseReceived == this.numberOfResponseWaiting) {
            this.status = Status.ALL_RESPONSES_RECEIVED;
        }
    }

}
