package fr.inria.gforge.dspace.overlay.reasoner;

import java.util.List;

import fr.inria.gforge.dspace.overlay.api.messages.query.SPARQLQuery;

/**
 * A {@link ParsedSPARQLQuery} contains some extra information about a SPARQL
 * query which has been analyzed. It contains several sub-queries to dispatch if
 * it has been considered useful to decompose the original query for routing.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: ParsedSPARQLQuery.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class ParsedSPARQLQuery {

    private boolean requireFiltration = false;

    private SPARQLQuery query;

    private List<SPARQLQuery> subQueries;

    public ParsedSPARQLQuery(boolean requireFilter, SPARQLQuery originalQuery,
	    List<SPARQLQuery> subQueries) {
	this.requireFiltration = requireFilter;
	this.query = originalQuery;
	this.subQueries = subQueries;
    }

    public boolean requireFiltration() {
	return this.requireFiltration;
    }

    public SPARQLQuery getQuery() {
	return this.query;
    }

    public List<SPARQLQuery> getSubQueries() {
	return this.subQueries;
    }

}
