package fr.inria.gforge.dspace.overlay.reasoner;

import java.io.Serializable;

import org.objectweb.proactive.extensions.structuredp2p.overlay.can.coordinates.CoordinateValue;


/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: RangeQueryCondition.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class RangeQueryCondition implements Serializable {

	private static final long serialVersionUID = 1L;

	private int index;

    private String var;

    private RangeQueryOperator.Type operator;

    private CoordinateValue coordinate;

    public RangeQueryCondition(int index, String var, RangeQueryOperator.Type operator, CoordinateValue coordinate) {
        super();
        this.var = var;
        this.operator = operator;
        this.coordinate = coordinate;
    }

    public int getIndex() {
        return this.index;
    }

    /**
     * @return the var
     */
    public String getVar() {
        return this.var;
    }

    /**
     * @return the operator
     */
    public RangeQueryOperator.Type getOperator() {
        return this.operator;
    }

    /**
     * @return the constant
     */
    public CoordinateValue getCoordinate() {
        return this.coordinate;
    }

    public String toString() {
        return "?" + this.var + " " + RangeQueryOperator.getValue(this.operator) + " " + this.coordinate;
    }

}
