package fr.inria.gforge.dspace.overlay.reasoner;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: RangeQueryOperator.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class RangeQueryOperator {

    public enum Type {
        AND, OR, EQUALS, GREATER, GREATER_EQUALS, LESS, LESS_EQUALS, NOT_EQUALS,
    }

    public static Type getType(String operator) {
        if (operator.equals("&&")) {
            return Type.AND;
        } else if (operator.equals("||")) {
            return Type.OR;
        } else if (operator.equals("==")) {
            return Type.EQUALS;
        } else if (operator.equals(">")) {
            return Type.GREATER;
        } else if (operator.equals(">=")) {
            return Type.GREATER_EQUALS;
        } else if (operator.equals("<")) {
            return Type.LESS;
        } else if (operator.equals("<=")) {
            return Type.LESS_EQUALS;
        } else if (operator.equals("!=")) {
            return Type.NOT_EQUALS;
        }
        return null;
    }

    public static String getValue(RangeQueryOperator.Type op) {
        switch (op) {
            case AND:
                return "&&";
            case OR:
                return "||";
            case EQUALS:
                return "==";
            case GREATER:
                return ">";
            case GREATER_EQUALS:
                return ">=";
            case LESS:
                return "<";
            case LESS_EQUALS:
                return "<=";
            case NOT_EQUALS:
                return "!=";
        }
        return null;
    }

}
