package fr.inria.gforge.dspace.overlay.util;

import java.io.File;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: DSpaceProperties.java 5041 2010-08-19 13:20:59Z plaurent $
 */
public class DSpaceProperties {

	public static final String DSPACE_CONFIGURATION_FILE = "dspace.configuration";

	public static final String DSPACE_REPOSITORY_RESTORE_ID = "dspace.repository.restore.id";
	
	private static final File defaultPathForConfigurationFiles;
	
	static {
		String prefix = System.getProperty("user.home") + "/";
		String suffix = "dspace";
		
		if (SystemUtil.isWindows()) {
			defaultPathForConfigurationFiles = new File(prefix + suffix);
		} else {
			defaultPathForConfigurationFiles = new File(prefix + "." + suffix);
		}
	}
	
	/**
	 * Returns the default path used for dspace configuration files.
	 * 
	 * @return the default path used for dspace configuration files.
	 */
	public static File getDefaultPathForConfigurationFiles() {
		return defaultPathForConfigurationFiles;		
	}

	public static String get(String property) {
		return System.getProperty(property);
	}
	
}
