package fr.inria.gforge.dspace.overlay.validator;

import org.objectweb.proactive.extensions.structuredp2p.messages.SynchronousMessage;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.can.Zone;
import org.objectweb.proactive.extensions.structuredp2p.validator.ConstraintsValidator;

/**
 * Used by {@link SynchronousMessage}s to known if the current
 * {@link StructuredOverlay} or {@link Zone} which handles the message validates
 * the constraints associated to key contained by the message.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: AnycastConstraintsValidator.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public interface AnycastConstraintsValidator<K> extends ConstraintsValidator<K> {

    abstract public boolean validatesKeyConstraints(Zone zone, K key);

}
