package fr.inria.gforge.dspace.overlay.performance;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: HudsonReport.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class HudsonReport {

    public final static String REPORT_PATH = "./target/performance-reports";

    private final static Logger logger = LoggerFactory.getLogger(HudsonReport.class);

    public static void reportToHudson(String fileName, double value) {
        try {
            File fileToWrite = new File(HudsonReport.REPORT_PATH, fileName + ".properties");
            
            if (logger.isInfoEnabled()) {
                logger.info("ReportToHudson with absolute path=" + fileToWrite.getAbsolutePath());
            }
            
            if (!fileToWrite.exists()) {
                fileToWrite.getParentFile().mkdirs();
            }
            FileWriter fw = new FileWriter(fileToWrite);
            BufferedWriter bw = new BufferedWriter(fw);
            bw.write("YVALUE=" + value);
            bw.newLine();
            bw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    
}
