package fr.inria.gforge.dspace.overlay.samples.commands.management;

import java.util.List;

import fr.inria.gforge.dspace.overlay.connector.ManagementConnector;
import fr.inria.gforge.dspace.overlay.samples.commands.Argument;
import fr.inria.gforge.dspace.overlay.samples.commands.Command;
import fr.inria.gforge.dspace.overlay.samples.managers.Manager;
import fr.inria.gforge.dspace.overlay.samples.managers.SemanticSpaceManagementManager;

/**
 * Commands that contains a {@link ManagementConnector} in order to simplify to
 * implement command which provide management functionalities.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: AbstractManagementCommand.java 5042 2010-08-19 14:00:48Z plaurent $
 */
public abstract class AbstractManagementCommand extends Command {

    public AbstractManagementCommand(Manager manager, String description, String[] commandShortcuts) {
        super(manager, description, commandShortcuts);
    }

    public AbstractManagementCommand(Manager manager, String string, String[] strings,
            List<Argument> asList) {
        super(manager, string, strings, asList);
    }

    public ManagementConnector getManagementConnector() {
    	return ((SemanticSpaceManagementManager) super.getManager()).getManagementConnector();
    }
    
}
