package fr.inria.gforge.dspace.overlay.samples.commands.management;

import fr.inria.gforge.dspace.overlay.samples.managers.Manager;

/**
 * Creates a new Chord peer and forces it to join the network.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: NewPeerOnChordCommand.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class NewPeerOnChordCommand extends AbstractManagementCommand {

    /**
     * Constructor.
     * 
     * @param manager
     *            the manager that will execute this command.
     */
    public NewPeerOnChordCommand(Manager manager) {
        super(manager, "Creates a new Chord peer and forces it to join the network", new String[] {
                "join-on-chord", "join-chord" });
    }

    /**
     * {@inheritDoc}
     */
    public void execute(String... args) {
        super.getManagementConnector().newPeerOnChord();
        super.info("New Chord node added.");
    }
    
}
