package fr.inria.gforge.dspace.overlay.samples.commands.management;

import org.objectweb.proactive.extensions.structuredp2p.overlay.Peer;

import at.sti2.semanticspaces.api.exceptions.SemanticSpaceException;
import fr.inria.gforge.dspace.overlay.samples.managers.Manager;

/**
 * Forces a {@link Peer} (randomly chosen) from the existing network to leave.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: RemovePeerOnChordCommand.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class RemovePeerOnChordCommand extends AbstractManagementCommand {

    /**
     * Constructor.
     * 
     * @param manager
     *            the manager that will execute this command.
     */
    public RemovePeerOnChordCommand(Manager manager) {
        super(manager, "Forces a Chord peer to leave", 
                new String[] { "leave-on-chord", "leave-chord" });
    }

    /**
     * {@inheritDoc}
     */
    public void execute(String... args) {
        try {
            super.getManagementConnector().removePeerOnChord();
        } catch (SemanticSpaceException e) {
            super.error(e.getMessage());
        }
        super.info("A Chord node has left the network.");
    }
    
}
