package fr.inria.gforge.dspace.overlay.samples.commands.operations;

import fr.inria.gforge.dspace.overlay.samples.commands.Command;
import fr.inria.gforge.dspace.overlay.samples.managers.Manager;

/**
 * Performs a quit command which terminates the application.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: QuitCommand.java 5038 2010-08-19 09:09:50Z plaurent $
 */
public class QuitCommand extends Command {

    /**
     * Constructor.
     * 
     * @param manager
     *            the manager that will execute this command.
     */
    public QuitCommand(Manager manager) {
        super(manager, "Quit the application", new String[] { "quit", "exit" });
    }

    /**
     * {@inheritDoc}
     */
    public void execute(String... args) {
        // ((SemanticSpaceOperationsManager)
        // super.getManager()).getConnector().leaveJoinedSpaces();
        super.getManager().stopExecution();
        System.exit(0);
    }

}
