#!/bin/sh

function killAllJvm() {
    killall -s 9 -q -u $USER java rmid rmiregistry;
    sleep 5
}

function killAllJvmEons() {
    maprsh -t 5 "killall -9 java rmid rmiregistry 2>/dev/null" @m-eon
}

function removeRepositories() {
    rm -rf ~/.dspace/repositories
}

EONS_CURRENT_PATH=$(dirname $0);
EONS_OUTPUT_DIR=$EONS_CURRENT_PATH/../benchmarks/eons
RUN_DATE=$(date "+%Y-%m-%d-%H-%M-%S")

echo "Benchmarks START ($1 peers, $2 statements)"
echo "  --> local"

mkdir -p $EONS_OUTPUT_DIR
. $EONS_CURRENT_PATH/benchmarks-launcher.sh -SL $1 $2 > $EONS_OUTPUT_DIR/console-local-$1-$2-$RUN_DATE 2>&1

killAllJvm
sleep 3
killAllJvmEons
removeRepositories

cp $EONS_CURRENT_PATH/../benchmarks/$(ls -rt $EONS_CURRENT_PATH/../benchmarks | grep Single | tail -1) $EONS_OUTPUT_DIR/local-$1-$2-$RUN_DATE

echo "  --> remote"

. $EONS_CURRENT_PATH/benchmarks-launcher.sh -SD $1 $2 > $EONS_OUTPUT_DIR/console-remote-$1-$2-$RUN_DATE 2>&1

cp $EONS_CURRENT_PATH/../benchmarks/$(ls -rt $EONS_CURRENT_PATH/../benchmarks | grep Distributed | tail -1) $EONS_OUTPUT_DIR/remote-$1-$2-$RUN_DATE
 
killAllJvmEons
sleep 3
killAllJvmEons
removeRepositories

echo "Benchmarks END"
