#!/bin/sh

CIKM_CURRENT_PATH=$(dirname $0);
CIKM_OUTPUT_DIR=$CIKM_CURRENT_PATH/../benchmarks/cikm
CIKM_OUTPUT_BENCHMARKS=$CIKM_CURRENT_PATH/../benchmarks/eons

DIRNAME_ADDSTATEMENTS_NB_THREADS_VARIATION=addstatements-nb-threads-variation
DIRNAME_ADDSTATEMENTS_NB_PEERS_VARIATION=addstatements-nb-peers-variation
DIRNAME_ADDSTATEMENTS_NB_STATEMENTS_VARIATION=addstatements-nb-statements-variation
DIRNAME_QUERIES_NB_RUNS_VARIATION=queries-nb-runs-variation
DIRNAME_QUERIES_NB_PEERS_VARIATION=queries-nb-peers-variation

function clean() {
    rm -rf $CIKM_OUTPUT_DIR;
    mkdir -p $CIKM_OUTPUT_DIR
    mkdir -p $CIKM_OUTPUT_DIR/$DIRNAME_ADDSTATEMENTS_NB_THREADS_VARIATION
    mkdir -p $CIKM_OUTPUT_DIR/$DIRNAME_ADDSTATEMENTS_NB_PEERS_VARIATION
    mkdir -p $CIKM_OUTPUT_DIR/$DIRNAME_ADDSTATEMENTS_NB_STATEMENTS_VARIATION
    mkdir -p $CIKM_OUTPUT_DIR/$DIRNAME_QUERIES_NB_RUNS_VARIATION
    mkdir -p $CIKM_OUTPUT_DIR/$DIRNAME_QUERIES_NB_PEERS_VARIATION
}

function addstatements_nb_threads_variation() {
    for ((j=1; j<=30; j++));
    do 
	mkdir -p $CIKM_OUTPUT_DIR/$DIRNAME_ADDSTATEMENTS_NB_THREADS_VARIATION/$j;
	export DSPACE_OVERLAY_BENCHMARKS_THREADS=$j;
	. $CIKM_CURRENT_PATH/benchmarks-eons.sh $1 $2;
	cp $CIKM_OUTPUT_BENCHMARKS/* $CIKM_OUTPUT_DIR/$DIRNAME_ADDSTATEMENTS_NB_THREADS_VARIATION/$j
	rm $CIKM_OUTPUT_BENCHMARKS/*;
    done;
}

function addstatements_nb_peers_variation_sub() {
    mkdir -p $CIKM_OUTPUT_DIR/$DIRNAME_ADDSTATEMENTS_NB_PEERS_VARIATION/$1;
    . $CIKM_CURRENT_PATH/benchmarks-eons.sh $1 $2;
    cp $CIKM_OUTPUT_BENCHMARKS/* $CIKM_OUTPUT_DIR/$DIRNAME_ADDSTATEMENTS_NB_PEERS_VARIATION/$1;
    rm $CIKM_OUTPUT_BENCHMARKS/*;
}

function addstatements_nb_peers_variation() {
    export DSPACE_OVERLAY_BENCHMARKS_THREADS=32;

    addstatements_nb_peers_variation_sub 1 $1
    for ((j=10; j<=100; j=j+10));
    do 
	addstatements_nb_peers_variation_sub $j $1
    done;
}

function addstatements_nb_statements_variation() {
    export DSPACE_OVERLAY_BENCHMARKS_THREADS=32;
    
    for ((j=1000; j<=$1; j=j+1000));
    do
	mkdir -p $CIKM_OUTPUT_DIR/$DIRNAME_ADDSTATEMENTS_NB_STATEMENTS_VARIATION/$j;
	. $CIKM_CURRENT_PATH/benchmarks-eons.sh 100 $j;
	cp $CIKM_OUTPUT_BENCHMARKS/* $CIKM_OUTPUT_DIR/$DIRNAME_ADDSTATEMENTS_NB_STATEMENTS_VARIATION/$j
	rm $CIKM_OUTPUT_BENCHMARKS/*;
    done;
}

function queries_nb_runs_variation() {
    for ((j=1; j<=$1; j++));
    do
	mkdir -p $CIKM_OUTPUT_DIR/$DIRNAME_QUERIES_NB_RUNS_VARIATION/$j;
	. $CIKM_CURRENT_PATH/benchmarks-eons.sh 100 1000;
	cp $CIKM_OUTPUT_BENCHMARKS/* $CIKM_OUTPUT_DIR/$DIRNAME_QUERIES_NB_RUNS_VARIATION/$j
	rm $CIKM_OUTPUT_BENCHMARKS/*;
    done;
}

function queries_nb_peers_variation_sub() {
    mkdir -p $CIKM_OUTPUT_DIR/$DIRNAME_QUERIES_NB_PEERS_VARIATION/$1;
    . $CIKM_CURRENT_PATH/benchmarks-eons.sh $1 $2;
    cp $CIKM_OUTPUT_BENCHMARKS/* $CIKM_OUTPUT_DIR/$DIRNAME_QUERIES_NB_PEERS_VARIATION/$1
    rm $CIKM_OUTPUT_BENCHMARKS/*;
}

function queries_nb_peers_variation() {
    queries_nb_peers_variation_sub 1 1000
    for ((j=10; j<=100; j=j+10));
    do
	mkdir -p $CIKM_OUTPUT_DIR/$DIRNAME_QUERIES_NB_PEERS_VARIATION/$j;
	. $CIKM_CURRENT_PATH/benchmarks-eons.sh $j 1000;
	cp $CIKM_OUTPUT_BENCHMARKS/* $CIKM_OUTPUT_DIR/$DIRNAME_QUERIES_NB_PEERS_VARIATION/$j
	rm $CIKM_OUTPUT_BENCHMARKS/*;
    done;
}

clean

# first param is nb peers, second is nb statements to add
# addstatements_nb_threads_variation 100 1000

# parameter is nb statements to add
addstatements_nb_peers_variation 1000

# stop at 5000 statements (increment = +1000)
# addstatements_nb_statements_variation 5000

# parameter is the number of runs
# queries_nb_runs_variation 10

#queries_nb_peers_variation
