#!/bin/sh

if [ -z $DSPACE_BUNDLE_HOME ];
then
	echo "DSPACE_BUNDLE_HOME not defined."
	exit 1;
fi

export PATH_TO_DEPLOYMENT=$DSPACE_BUNDLE_HOME/deployment
export PATH_TO_RESOURCES=$DSPACE_BUNDLE_HOME/resources

unset CLASSPATH

# Cannot only use wildcard because if jar name contains
# '.' character there are some problems
CLASSPATH="${DSPACE_BUNDLE_HOME}/lib/*"
for jar in $(ls $DSPACE_BUNDLE_HOME/lib/);
do
    CLASSPATH="${DSPACE_BUNDLE_HOME}/lib/${jar}:${CLASSPATH}"
done;

export CLASSPATH

if [ $DEBUG ];
then
    echo "--> Using PATH_TO_DEPLOYMENT=${PATH_TO_DEPLOYMENT}"
    echo "--> Using PATH_TO_RESOURCES=${PATH_TO_RESOURCES}"
    echo "--> Using DSPACE_BUNDLE_HOME=${DSPACE_BUNDLE_HOME}"
fi