package org.objectweb.proactive.extensions.structuredp2p.exceptions;

import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;

/**
 * An exception thrown when an error occurs from a {@link StructuredOverlay} of
 * type Chord.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: ChordException.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class ChordException extends StructuredP2PException {
    
    private static final long serialVersionUID = 1L;

    /**
     * Constructs a <code>ChordException</code> with no specified detail
     * message.
     */
    public ChordException() {
        super();
    }

    /**
     * Constructs a <code>ChordException</code> with the specified
     * detail message.
     * 
     * @param message
     *            the detail message.
     */
    public ChordException(String message) {
        super(message);
    }

    /**
     * Constructs a <code>ChordException</code> with the specified
     * detail message and nested exception.
     * 
     * @param message
     *            the detail message.
     * @param cause
     *            the nested exception.
     */
    public ChordException(String message, Throwable cause) {
        super(message, cause);
    }

    /**
     * Constructs a <code>ChordException</code> with the specified
     * detail message and nested exception.
     * 
     * @param cause
     *            the nested exception.
     */
    public ChordException(Throwable cause) {
        super(cause);
    }

}
