package org.objectweb.proactive.extensions.structuredp2p.exceptions;

import org.objectweb.proactive.extensions.structuredp2p.api.messages.Query;
import org.objectweb.proactive.extensions.structuredp2p.overlay.QueryManager;

/**
 * An exception thrown when an error occurs while dispatching a {@link Query}
 * from a {@link QueryManager}.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: DispatchException.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class DispatchException extends StructuredP2PException {

    private static final long serialVersionUID = 1L;

    /**
     * Constructs a <code>DispatchException</code> with no specified detail
     * message.
     */
    public DispatchException() {
        super();
    }

    /**
     * Constructs a <code>DispatchException</code> with the specified detail
     * message.
     * 
     * @param message
     *            the detail message.
     */
    public DispatchException(String message) {
        super(message);
    }

    /**
     * Constructs a <code>DispatchException</code> with the specified detail
     * message and nested exception.
     * 
     * @param message
     *            the detail message.
     * @param cause
     *            the nested exception.
     */
    public DispatchException(String message, Throwable cause) {
        super(message, cause);
    }

    /**
     * Constructs a <code>DispatchException</code> with the specified detail
     * message and nested exception.
     * 
     * @param cause
     *            the nested exception.
     */
    public DispatchException(Throwable cause) {
        super(cause);
    }

}
