package org.objectweb.proactive.extensions.structuredp2p.exceptions;

import org.objectweb.proactive.extensions.structuredp2p.overlay.Peer;

/**
 * An exception thrown when the {@link Peer#join(Peer)} method from a
 * {@link Peer} is called whereas it has already been called and it has
 * succeeded.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: NetworkAlreadyJoinedException.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class NetworkAlreadyJoinedException extends StructuredP2PException {

    private static final long serialVersionUID = 1L;

    /**
     * Constructs a <code>NetworkAlreadyJoinedException</code> with no specified
     * detail message.
     */
    public NetworkAlreadyJoinedException() {
        super();
    }

}
