package org.objectweb.proactive.extensions.structuredp2p.exceptions;

import org.objectweb.proactive.extensions.structuredp2p.overlay.Peer;

/**
 * An exception thrown when the {@link Peer#leave()} method from a {@link Peer}
 * is called whereas the peer has not joined a network by using
 * {@link Peer#join(Peer)}.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: NetworkNotJoinedException.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class NetworkNotJoinedException extends StructuredP2PException {

    private static final long serialVersionUID = 1L;

    /**
     * Constructs a <code>NetworkNotJoinedException</code> with no specified
     * detail message.
     */
    public NetworkNotJoinedException() {
        super();
    }

}
