package org.objectweb.proactive.extensions.structuredp2p.exceptions;

/**
 * An exception thrown when a problem occurs by using objects from the
 * structured p2p extension.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: StructuredP2PException.java 4667 2010-05-26 14:20:22Z laurentp
 *          $
 */
public class StructuredP2PException extends Exception {

    private static final long serialVersionUID = 1L;

    /**
     * Constructs a <code>StructuredP2PException</code> with no specified detail
     * message.
     */
    public StructuredP2PException() {
        super();
    }

    /**
     * Constructs a <code>StructuredP2PException</code> with the specified
     * detail message.
     * 
     * @param message
     *            the detail message.
     */
    public StructuredP2PException(String message) {
        super(message);
    }

    /**
     * Constructs a <code>StructuredP2PException</code> with the specified
     * detail message and nested exception.
     * 
     * @param message
     *            the detail message.
     * @param cause
     *            the nested exception.
     */
    public StructuredP2PException(String message, Throwable cause) {
        super(message, cause);
    }

    /**
     * Constructs a <code>StructuredP2PException</code> with the specified
     * detail message and nested exception.
     * 
     * @param cause
     *            the nested exception.
     */
    public StructuredP2PException(Throwable cause) {
        super(cause);
    }

}
