package org.objectweb.proactive.extensions.structuredp2p.messages.query.chord;

import org.objectweb.proactive.extensions.structuredp2p.messages.response.chord.FingerResponseMessage;
import org.objectweb.proactive.extensions.structuredp2p.messages.response.chord.PeerExistsResponseMessage;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.AbstractChordOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Key;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: PeerExistsQueryMessage.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class PeerExistsQueryMessage extends FingerQueryMessage {

    private static final long serialVersionUID = 1L;

    private boolean keyToReachExists = false;

    public PeerExistsQueryMessage(Key keyToReach) {
	super(keyToReach);
    }

    public FingerResponseMessage createResponseMessage() {
	return new PeerExistsResponseMessage(this, super.senderKey);
    }

    public void onDestinationReached(StructuredOverlay overlay) {
	if (((AbstractChordOverlay<?>) overlay).getKey().equals(super.getKeyToReach())) {
	    this.keyToReachExists = true;
	}
    }

    public boolean keyAlreadyUsed() {
        return this.keyToReachExists;
    }
    
}