package org.objectweb.proactive.extensions.structuredp2p.messages.response.chord;

import org.objectweb.proactive.extensions.structuredp2p.api.messages.Response;
import org.objectweb.proactive.extensions.structuredp2p.messages.query.chord.FingerQueryMessage;
import org.objectweb.proactive.extensions.structuredp2p.messages.response.AbstractResponseMessage;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.AbstractChordOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Key;
import org.objectweb.proactive.extensions.structuredp2p.router.Router;
import org.objectweb.proactive.extensions.structuredp2p.router.chord.FingerResponseRouter;
import org.objectweb.proactive.extensions.structuredp2p.validator.ConstraintsValidator;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: FingerResponseMessage.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class FingerResponseMessage extends AbstractResponseMessage<Key> {

    private static final long serialVersionUID = 1L;

    public FingerResponseMessage(FingerQueryMessage query, final Key keyToReach) {
        super(query, keyToReach);
    }

    /**
     * Nothing to do because {@link FingerResponseMessage} is not accessible
     * from the public API.
     */
    public Response createResponse() {
        return null;
    }

    /**
     * {@inheritDoc}
     */
    public Router<FingerResponseMessage, Key> getRouter() {
        return new FingerResponseRouter<FingerResponseMessage>(new ConstraintsValidator<Key>() {
            public boolean validatesKeyConstraints(StructuredOverlay overlay, Key key) {
                return getKeyToReach().equals(((AbstractChordOverlay<?>) overlay).getKey());
            }
        });
    }

}
