package org.objectweb.proactive.extensions.structuredp2p.messages.response.chord;

import java.util.List;

import org.objectweb.proactive.extensions.structuredp2p.api.messages.Response;
import org.objectweb.proactive.extensions.structuredp2p.messages.SynchronousMessage;
import org.objectweb.proactive.extensions.structuredp2p.messages.query.chord.TurnAroundQueryMessage;
import org.objectweb.proactive.extensions.structuredp2p.messages.response.AbstractResponseMessage;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Key;
import org.objectweb.proactive.extensions.structuredp2p.router.Router;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: TurnAroundResponseMessage.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class TurnAroundResponseMessage<V> extends AbstractResponseMessage<Key> {

    private static final long serialVersionUID = 1L;

    private List<V> values;
    
    public TurnAroundResponseMessage(TurnAroundQueryMessage<V> query, Key keyToReach) {
        super(query, keyToReach);
        this.values = query.getValues();
    }

    /**
     * Nothing to do because TurnAroundResponseMessage is not accessible from the
     * public API.
     */
    public Response createResponse() {
        return null;
    }

    /**
     * Doesn't need to implement this method because query is routed from
     * initial sender to initial sender. When the response is created, it is on
     * the initial sender.
     */
    public Router<SynchronousMessage<Key>, Key> getRouter() {
        return null; 
    }

    public List<V> getValues() {
        return this.values;
    }

}
