package org.objectweb.proactive.extensions.structuredp2p.operations;

import java.io.Serializable;

import org.objectweb.proactive.extensions.structuredp2p.overlay.Peer;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;

/**
 * An Operation is a special message that is sent from a {@link Peer} to an another
 * {@link Peer} in one hop by using an RPC call (via ProActive) without routing
 * steps.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: Operation.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public interface Operation extends Serializable {

    /**
     * Handles the message by using the specified <code>overlay</code>.
     * 
     * @param overlay
     *            the {@link StructuredOverlay} to use in order to handle the
     *            message.
     * @return a response associated to the message handled.
     */
    public abstract ResponseOperation handle(StructuredOverlay overlay);

}
