package org.objectweb.proactive.extensions.structuredp2p.operations.can;

import org.objectweb.proactive.extensions.structuredp2p.operations.Operation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.can.AbstractCANOverlay;

/**
 * Message used to retrieve identifier and zone of a peer of type CAN.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: GetIdAndZoneOperation.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class GetIdAndZoneOperation implements Operation {

    private static final long serialVersionUID = 1L;

    public GetIdAndZoneOperation() {

    }

    /**
     * Handles the message.
     * 
     * @param overlay
     *            the overlay which handles the message.
     */
    public GetIdAndZoneResponseOperation handle(StructuredOverlay overlay) {
        return new GetIdAndZoneResponseOperation(overlay.getLocalPeer().getIdentifier(),
                ((AbstractCANOverlay) overlay).getZone());
    }

}
