package org.objectweb.proactive.extensions.structuredp2p.operations.can;

import java.util.UUID;

import org.objectweb.proactive.extensions.structuredp2p.operations.ResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.can.Zone;

/**
 * Response associated to {@link GetIdAndZoneOperation}.
 * 
 * @version $Id: GetIdAndZoneResponseOperation.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class GetIdAndZoneResponseOperation implements ResponseOperation {

    private static final long serialVersionUID = 1L;

    private final UUID peerIdentifier;

    private final Zone peerZone;

    public GetIdAndZoneResponseOperation(UUID peerIdentifier, Zone peerZone) {
        super();
        this.peerIdentifier = peerIdentifier;
        this.peerZone = peerZone;
    }

    public UUID getPeerIdentifier() {
        return this.peerIdentifier;
    }

    public Zone getPeerZone() {
        return this.peerZone;
    }

}
