package org.objectweb.proactive.extensions.structuredp2p.operations.can;

import java.util.UUID;

import org.objectweb.proactive.extensions.structuredp2p.operations.BooleanResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.Operation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.can.AbstractCANOverlay;

/**
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: HasMetSynchronousMessageOperation.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class HasMetSynchronousMessageOperation implements Operation {

    private static final long serialVersionUID = 1L;
    
    private final UUID uuid;

    public UUID getUuid() {
        return uuid;
    }

    public HasMetSynchronousMessageOperation(UUID uuid) {
        this.uuid = uuid;
    }

    /**
     * {@inheritDoc}
     */
    public BooleanResponseOperation handle(StructuredOverlay overlay) {
        return new BooleanResponseOperation(((AbstractCANOverlay) overlay)
                .getSynchronousMessagesIdentifiersMet().contains(this.uuid));
    }
    
}
