package org.objectweb.proactive.extensions.structuredp2p.operations.can;

import java.util.UUID;

import org.objectweb.proactive.extensions.structuredp2p.operations.BooleanResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.Operation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.can.AbstractCANOverlay;

/**
 * Message used in order to check if a peer has a specified peer identifier as
 * neighb6or.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: HasMetSynchronousMessageOperation.java 3470 2010-02-24 10:09:53Z
 *          laurentp $
 */
public class HasNeighborOperation implements Operation {

    private static final long serialVersionUID = 1L;
    
    private final UUID uuid;

    public HasNeighborOperation(UUID uuid) {
        this.uuid = uuid;
    }

    /**
     * {@inheritDoc}
     */
    public BooleanResponseOperation handle(StructuredOverlay overlay) {
        return new BooleanResponseOperation(((AbstractCANOverlay) overlay).hasNeighbor(this.uuid));
    }

}
