package org.objectweb.proactive.extensions.structuredp2p.operations.chord;

import java.util.Map;

import org.objectweb.proactive.extensions.structuredp2p.operations.ResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.BooleanResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.Operation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.AbstractChordOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Entry;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Key;

/**
 * Add all the given entries to the {@link AbstractChordOverlay} which handles
 * the message.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: AddEntriesOperation.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class AddEntriesOperation<T> implements Operation {

    private static final long serialVersionUID = 1L;

    private Map<Key, Entry<T>> entriesToAdd;

    /**
     * Constructor.
     * 
     * @param entries
     *            the entries to add.
     */
    public AddEntriesOperation(Map<Key, Entry<T>> entries) {
        this.entriesToAdd = entries;
    }

    @SuppressWarnings("unchecked")
    public ResponseOperation handle(StructuredOverlay overlay) {
        return new BooleanResponseOperation(
                ((AbstractChordOverlay<T>) overlay).addEntries(
                        this.entriesToAdd));
    }

}
