package org.objectweb.proactive.extensions.structuredp2p.operations.chord;

import org.objectweb.proactive.extensions.structuredp2p.operations.ResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.BooleanResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.Operation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.AbstractChordOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Entry;

/**
 * Add a new entry to the {@link AbstractChordOverlay} which handles the message.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: AddEntryOperation.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class AddEntryOperation<T> implements Operation {

    private static final long serialVersionUID = 1L;

    private Entry<T> entry;

    /**
     * Constructor.
     * 
     * @param entry
     *            the entry to add.
     */
    public AddEntryOperation(Entry<T> entry) {
        this.entry = entry;
    }
    
    @SuppressWarnings("unchecked")
    public ResponseOperation handle(StructuredOverlay overlay) {
        return new BooleanResponseOperation(((AbstractChordOverlay<T>) overlay).addEntry(entry));
    }

}
