package org.objectweb.proactive.extensions.structuredp2p.operations.chord;

import org.objectweb.proactive.extensions.structuredp2p.exceptions.ChordException;
import org.objectweb.proactive.extensions.structuredp2p.operations.ResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.BooleanResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.EmptyResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.Operation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.AbstractChordOverlay;

/**
 * Initialize the peer. This message is handled only by the first peer which
 * join the network.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: CreateNetworkOperation.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class CreateNetworkOperation implements Operation {

    private static final long serialVersionUID = 1L;

    /**
     * Constructor.
     */
    public CreateNetworkOperation() {
    }

    public ResponseOperation handle(StructuredOverlay overlay) {
        try {
            return new BooleanResponseOperation(((AbstractChordOverlay<?>) overlay).create());
        } catch (ChordException e) {
            e.printStackTrace();
            return new EmptyResponseOperation();
        }
    }
}
