package org.objectweb.proactive.extensions.structuredp2p.operations.chord;

import org.objectweb.proactive.extensions.structuredp2p.operations.ResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Entry;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: EntryResponseOperation.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class EntryResponseOperation<T> implements ResponseOperation {

    private static final long serialVersionUID = 1L;
    
    private Entry<T> entryFound;

    /**
     * Constructor.
     * 
     * @param entry
     *            the entry to transport.
     */
    public EntryResponseOperation(Entry<T> entry) {
        this.entryFound = entry;
    }

    /**
     * Returns the entry associated to this message.
     * 
     * @return the entry associated to this message.
     */
    public Entry<T> getEntryFound() {
        return this.entryFound;
    }

}
