package org.objectweb.proactive.extensions.structuredp2p.operations.chord;

import org.objectweb.proactive.extensions.structuredp2p.operations.ResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.Operation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.AbstractChordOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Entry;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Key;

/**
 * Lookup an {@link Entry} by {@link Key}.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: FindEntryOperation.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class FindEntryOperation implements Operation {

    private static final long serialVersionUID = 1L;

    private Key keyToUse;

    /**
     * Constructor.
     * 
     * @param key
     *            the key associated to the entry to lookup.
     */
    public FindEntryOperation(Key key) {
        this.keyToUse = key;
    }

    @SuppressWarnings({ "unchecked", "rawtypes" })
    public ResponseOperation handle(StructuredOverlay overlay) {
        return new EntryResponseOperation(
                ((AbstractChordOverlay<?>) overlay).findEntry(this.keyToUse));
    }
    
}
