package org.objectweb.proactive.extensions.structuredp2p.operations.chord;

import org.objectweb.proactive.extensions.structuredp2p.operations.ResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.BooleanResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.Operation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.Peer;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.AbstractChordOverlay;

/**
 * Notify the predecessor by the call to
 * {@link AbstractChordOverlay#notifyPredecessor(org.objectweb.proactive.extensions.structuredp2p.overlay.Peer)}
 * .
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: NotifyPredecessorOperation.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class NotifyPredecessorOperation implements Operation {

    private static final long serialVersionUID = 1L;
    
    private Peer notifyOf;

    /**
     * Constructor.
     */
    public NotifyPredecessorOperation(Peer notifyOf) {
        this.notifyOf = notifyOf;
    }

    public ResponseOperation handle(StructuredOverlay overlay) {
        return new BooleanResponseOperation(
                ((AbstractChordOverlay<?>) overlay).notifyPredecessor(
                        this.notifyOf));
    }
}
