package org.objectweb.proactive.extensions.structuredp2p.operations.chord;

import org.objectweb.proactive.extensions.structuredp2p.operations.ResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.BooleanResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.Operation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.AbstractChordOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Key;

/**
 * Removes the entry associated to the specified key when this message is
 * handled.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: RemoveEntryOperation.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class RemoveEntryOperation implements Operation {

    private static final long serialVersionUID = 1L;
    
    private Key keyToUse;

    /**
     * Constructor.
     * 
     * @param key
     *            the key associated to the entry we want to remove.
     */
    public RemoveEntryOperation(Key key) {
        this.keyToUse = key;
    }

    public ResponseOperation handle(StructuredOverlay overlay) {
        return new BooleanResponseOperation(((AbstractChordOverlay<?>) overlay)
                .removeEntry(this.keyToUse));
    }
}
