package org.objectweb.proactive.extensions.structuredp2p.operations.chord;

import org.objectweb.proactive.extensions.structuredp2p.operations.ResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.BooleanResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.Operation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.Peer;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.AbstractChordOverlay;

/**
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: SetSuccessorOperation.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class SetSuccessorOperation implements Operation {

    private static final long serialVersionUID = 1L;
    
    private Peer successorToSet;

    public SetSuccessorOperation(Peer successor) {
        this.successorToSet = successor;
    }

    public ResponseOperation handle(StructuredOverlay overlay) {
        ((AbstractChordOverlay<?>) overlay).setSuccessor(this.successorToSet);
        return new BooleanResponseOperation(true);
    }

}
