package org.objectweb.proactive.extensions.structuredp2p.overlay.can;

import org.objectweb.proactive.extensions.structuredp2p.exceptions.ContentAdressableNetworkException;

/**
 * An {@code ZoneException} is thrown by certain methods of the {@link Zone}
 * class.
 * 
 * @author Alexandre Trovato
 * @author Fanny Kilanga
 * @author Laurent Pellegrino
 * 
 * @version $Id: ZoneException.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class ZoneException extends ContentAdressableNetworkException {

    private static final long serialVersionUID = 1L;

    /**
     * Constructs an {@code ZoneException} with the specified detail message. A
     * detail message is a {@link String} that describes this particular
     * exception.
     * 
     * @param message
     *            the detail message.
     */
    public ZoneException(String message) {
        super(message);
    }

    /**
     * Constructs an {@code ZoneException} with the specified detail message and
     * cause.
     * 
     * @param message
     *            the detail message.
     * @param cause
     *            the cause.
     */
    public ZoneException(String message, Throwable cause) {
        super(message, cause);
    }

    /**
     * Constructs an {@code ZoneException} with the specified cause.
     * 
     * @param cause
     *            the cause.
     */
    public ZoneException(Throwable cause) {
        super(cause);
    }

}
