package org.objectweb.proactive.extensions.structuredp2p.overlay.chord;

import org.objectweb.proactive.extensions.structuredp2p.api.messages.Query;
import org.objectweb.proactive.extensions.structuredp2p.api.messages.Response;
import org.objectweb.proactive.extensions.structuredp2p.messages.SynchronousMessage;
import org.objectweb.proactive.extensions.structuredp2p.messages.SynchronousMessageEntry;
import org.objectweb.proactive.extensions.structuredp2p.messages.response.AbstractResponseMessage;
import org.objectweb.proactive.extensions.structuredp2p.overlay.QueryManager;

public class DefaultChordQueryManager extends QueryManager {

    private static final long serialVersionUID = 1L;

    /**
     * Overrides processFirstRoute in order to handle the query from the sender
     * successor for avoiding to reach the initial sender two times.
     */
    protected void processInitialSent(SynchronousMessage<?> msg) {
        super.overlay.getSynchronousMessagesReceived().put(msg.getUUID(),
                new SynchronousMessageEntry(1, msg.getHopCount()));
        msg.route(super.overlay);
    }

    /*
     * No query from public API.
     */
    protected Response postProcess(Query initialQuery, AbstractResponseMessage<?> response) {
        return null;
    }

    protected SynchronousMessage<?> preProcess(Query query) {
        return null;
    }

    /*
     * No data to retrieve.
     */
    public SynchronousMessageEntry mergeAndSetSynchronousMessage(SynchronousMessage<?> msg) {
        return null;
    }

    public SynchronousMessageEntry setSynchronousMessage(SynchronousMessage<?> msg) {
        return null;
    }

}
