package org.objectweb.proactive.extensions.structuredp2p.validator;

import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.router.Router;

/**
 * Used by {@link Router}s to known if the current {@link StructuredOverlay}
 * which handles the message validates the constraints associated to key
 * contained by the message.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: ConstraintsValidator.java 5022 2010-08-14 16:14:45Z plaurent $
 * 
 * @param <K>
 *            the type of the key used to check if constraints are validated.
 */
public interface ConstraintsValidator<K> {

    abstract public boolean validatesKeyConstraints(StructuredOverlay overlay, K key);
    
}
