package org.objectweb.proactive.extensions.structuredp2p.validator.can;

import org.objectweb.proactive.extensions.structuredp2p.messages.query.can.LookupQueryMessage;
import org.objectweb.proactive.extensions.structuredp2p.messages.response.can.LookupResponseMessage;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.can.AbstractCANOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.can.coordinates.CoordinateValue;
import org.objectweb.proactive.extensions.structuredp2p.validator.ConstraintsValidator;

/**
 * {@link ConstraintsValidator} for {@link LookupQueryMessage} and
 * {@link LookupResponseMessage}.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: UnicastConstraintsValidator.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class UnicastConstraintsValidator implements ConstraintsValidator<CoordinateValue[]> {

    private static final long serialVersionUID = 1L;

    public boolean validatesKeyConstraints(StructuredOverlay overlay, CoordinateValue[] key) {
        return ((AbstractCANOverlay) overlay).contains(key);
    }

}
