package org.objectweb.proactive.extensions.structuredp2p.core.overlay.chord;

import java.math.BigInteger;

import junit.framework.Assert;

import org.junit.Test;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Key;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: TestKey.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class TestKey {

    @Test
    public void testCompareTo() {
        Assert.assertTrue(new Key(1).compareTo(new Key(3)) < 0);
        Assert.assertFalse(new Key(2).compareTo(new Key(0)) < 0);
    }

    @Test
    public void testIsBetween() {
        Assert.assertTrue(new Key(5).isBetween(new Key(0), new Key(10)));
        Assert.assertTrue(new Key(11).isBetween(new Key(7), new Key(3)));
        Assert.assertFalse(new Key(5).isBetween(new Key(1), new Key(4)));
    }

    @Test
    public void testModulo() {
        BigInteger maxValue = BigInteger.valueOf(2).pow(Key.NB_BITS);
        BigInteger minValue = BigInteger.ZERO;
        Key largeKey = new Key((int) Math.pow(2, Key.NB_BITS) + 3);

        Assert.assertTrue(largeKey.getValue().compareTo(maxValue) < 0);
        Assert.assertTrue(largeKey.getValue().compareTo(minValue) >= 0);
    }
}
