package org.objectweb.proactive.extensions.structuredp2p.initializers;

import org.objectweb.proactive.ActiveObjectCreationException;
import org.objectweb.proactive.core.node.NodeException;
import org.objectweb.proactive.extensions.structuredp2p.api.PeerFactory;
import org.objectweb.proactive.extensions.structuredp2p.core.overlay.BasicCANOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.Peer;

/**
 * Specific network initializer for CAN network.
 * 
 * @author Laurent Pellegrino
 * 
 * @version $Id: CANNetworkInitializer.java 5024 2010-08-15 08:13:44Z plaurent $
 */
public class CANNetworkInitializer extends NetworkInitializer {

    public Peer createPeer() throws ActiveObjectCreationException, NodeException {
        return PeerFactory.newActivePeer(new BasicCANOverlay());
    }

}
