package org.objectweb.proactive.extensions.structuredp2p.messages.chord;

import org.objectweb.proactive.extensions.structuredp2p.messages.query.chord.FingerQueryMessage;
import org.objectweb.proactive.extensions.structuredp2p.messages.response.chord.FingerResponseMessage;
import org.objectweb.proactive.extensions.structuredp2p.overlay.StructuredOverlay;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Key;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: MyFingerQueryMessage.java 5022 2010-08-14 16:14:45Z plaurent $
 */
public class MyFingerQueryMessage extends FingerQueryMessage {

    private static final long serialVersionUID = 1L;

    private boolean destinationReached = false;

    public MyFingerQueryMessage(Key keyToReach) {
	super(keyToReach);
    }

    public FingerResponseMessage createResponseMessage() {
	return new MyFingerResponseMessage(this, this.senderKey);
    }

    public void onDestinationReached(StructuredOverlay overlay) {
	this.destinationReached = true;
    }

    public boolean isDestinationReached() {
	return this.destinationReached;
    }
    
}