package org.objectweb.proactive.extensions.structuredp2p.messages.chord;

import java.io.Serializable;

import junit.framework.Assert;

import org.junit.Before;
import org.junit.Test;
import org.objectweb.proactive.api.PAFuture;
import org.objectweb.proactive.core.util.ProActiveRandom;
import org.objectweb.proactive.extensions.structuredp2p.initializers.ChordNetworkInitializer;
import org.objectweb.proactive.extensions.structuredp2p.operations.chord.GetKeyOperation;
import org.objectweb.proactive.extensions.structuredp2p.operations.chord.GetKeyResponseOperation;
import org.objectweb.proactive.extensions.structuredp2p.overlay.OverlayType;
import org.objectweb.proactive.extensions.structuredp2p.overlay.chord.Key;

/**
 * @author Laurent Pellegrino
 * 
 * @version $Id: TestFingerQueryMessage.java 3576 2010-03-04 15:20:20Z laurentp
 *          $
 */
public class TestFingerQueryMessage extends ChordNetworkInitializer implements Serializable {

    private static final long serialVersionUID = 1L;
    
    private static final int NB_NODES_TO_CREATE = 10;

    @Before
    public void testCreation() {
        try {
            super.initializeNewNetwork(OverlayType.CHORD, NB_NODES_TO_CREATE);
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    @Test(timeout = 30000)
    public void testFingerQueryMessage() {
        Key keyToReach = ((GetKeyResponseOperation) PAFuture.getFutureValue(
        		super.get(1 + ProActiveRandom.nextInt(NB_NODES_TO_CREATE - 1)).send(
        			new GetKeyOperation()))).getKey();
        
        MyFingerResponseMessage response = 
            ((MyFingerResponseMessage) PAFuture.getFutureValue(
        	    super.get(0).send(new MyFingerQueryMessage(keyToReach))));

        Assert.assertTrue(response.getOutboundHopCount() > 0);
        Assert.assertTrue(response.isDestinationReached());
    }

}
