package org.objectweb.proactive.extensions.structuredp2p.operations.can;

import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Ignore;
import org.objectweb.proactive.extensions.structuredp2p.exceptions.StructuredP2PException;
import org.objectweb.proactive.extensions.structuredp2p.initializers.CANNetworkInitializer;
import org.objectweb.proactive.extensions.structuredp2p.overlay.OverlayType;
import org.objectweb.proactive.extensions.structuredp2p.overlay.can.AbstractCANOverlay;

/**
 * Test cases for the Join operation in {@link AbstractCANOverlay}.
 * 
 * TODO remove abstract when CAN leave works.
 * 
 * @author Laurent Pellegrino
 * @version 10/03/2009
 */
public abstract class TestLeaveOperation extends CANNetworkInitializer {

    @Before
    public void setUp() throws Exception {
        super.initializeNewNetwork(OverlayType.CAN, 4);
    }

    @Ignore
    public void testLeave() {
        int second = TestJoinOperation.getOverlay(super.get(1)).getNeighborTable().size();

        try {
            Assert.assertTrue(super.get(3).leave());
        } catch (StructuredP2PException e) {
            e.printStackTrace();
        }

        Assert.assertEquals(second - 1, TestJoinOperation.getOverlay(super.get(2)).getNeighborTable()
                .size());

        // Does the remote reference of the peer which has left has been
        // removed from the neighbors table ?
        Assert.assertFalse(TestJoinOperation.getOverlay(super.get(0)).hasNeighbor(super.get(3).getIdentifier()));
        Assert.assertFalse(TestJoinOperation.getOverlay(super.get(1)).hasNeighbor(super.get(3).getIdentifier()));
        Assert.assertFalse(TestJoinOperation.getOverlay(super.get(2)).hasNeighbor(super.get(3).getIdentifier()));

        // Do peers contain themself in neighbor table ?
        Assert.assertFalse(TestJoinOperation.getOverlay(super.get(0)).hasNeighbor(super.get(0).getIdentifier()));
        Assert.assertFalse(TestJoinOperation.getOverlay(super.get(1)).hasNeighbor(super.get(1).getIdentifier()));
        Assert.assertFalse(TestJoinOperation.getOverlay(super.get(2)).hasNeighbor(super.get(2).getIdentifier()));
    }

    @After
    public void tearDown() throws Exception {
        // super.clearNetwork();
    }

}
