/*
 * Copyright (C) 2010

 * STI Innsbruck
 * ICT - Technologie Park Innsbruck, 2nd Floor
 * Technikerstrasse 21a
 * A-6020 Innsbruck, Austria 
 * 
 * Contact:
 * reto.krummenacher@sti2.at
 * gerald.schrempf@sti2.at (development)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301, USA.
 */

package at.sti2.semanticspaces.api;

import org.ontoware.rdf2go.model.node.URI;

import at.sti2.semanticspaces.api.exceptions.SemanticSpaceException;

/**
 * notifications are only allowed at the moment
 * if underlying model is OwlimModel. (gerald.schrempf@sti2.at, 21.05.2010)
 */
public interface ISemanticSpaceNotification {

    // ***** NOTIFICATION SERVICES METHODS *****//
    public URI subscribe(String query, ISemanticSpaceListener listener) throws SemanticSpaceException;
    public void unsubscribe(URI subscription) throws SemanticSpaceException;

}
