/*
 * Copyright (C) 2010

 * STI Innsbruck
 * ICT - Technologie Park Innsbruck, 2nd Floor
 * Technikerstrasse 21a
 * A-6020 Innsbruck, Austria 
 * 
 * Contact:
 * reto.krummenacher@sti2.at
 * gerald.schrempf@sti2.at (development)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301, USA.
 */
package at.sti2.semanticspaces.api.enums;

import org.ontoware.rdf2go.model.node.URI;
import org.ontoware.rdf2go.model.node.impl.URIImpl;

import at.sti2.semanticspaces.api.spaceOntology.SpaceOntology;

/**
 * The allowed SpaceRelations for public modification of the metadataSpace.
 * 
 * @author gersch
 *
 */
public enum SpaceRelation  {
    tsonto_hasSubspace,
    tsonto_isSubspaceof,
    tsonto_isSimilarTo,
    tsonto_isRelatedTo,
    tsonto_seeAlsoSpace;
    
    final private URI uri;
    
    /**
     * creates an URI for each SpaceRelation.
     * @param relation
     */
    SpaceRelation(){
        this.uri = new URIImpl(SpaceOntology.tsonto.toString() + this.toString());
    }
    
    public URI getURI() {
        return uri;
    }
    
    /**
     * converts from relationURI to SpaceRelation.
     * @param relationURI
     * @return
     */
    public static SpaceRelation getSpaceRelation(URI relationURI) {
        String relationString = relationURI.toString().substring(SpaceOntology.tsonto.toString().length());
        return SpaceRelation.valueOf(relationString);
    }
}