/*
 * Copyright (C) 2010
 * 
 * STI Innsbruck ICT - Technologie Park Innsbruck, 2nd Floor Technikerstrasse
 * 21a A-6020 Innsbruck, Austria
 * 
 * Contact: reto.krummenacher@sti2.at gerald.schrempf@sti2.at (development)
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
package at.sti2.semanticspaces.api.exceptions;

import org.ontoware.rdf2go.exception.ModelRuntimeException;

/**
 * Exception for implementations of the RDF2GO.Model interface.
 * @author Gerald Schrempf
 *
 */

public class SpaceModelRuntimeException extends ModelRuntimeException {
    private static final long serialVersionUID = 1L;

    public SpaceModelRuntimeException() {
    	super();
    }
    
    public SpaceModelRuntimeException(String message) {
        super(message);
    }

    public SpaceModelRuntimeException(String message, Throwable t) {
        super(message, t);
    }

    public SpaceModelRuntimeException(Throwable t) {
        super(t);
    }
}
