/*
 * Copyright (C) 2010

 * STI Innsbruck
 * ICT - Technologie Park Innsbruck, 2nd Floor
 * Technikerstrasse 21a
 * A-6020 Innsbruck, Austria 
 * 
 * Contact:
 * reto.krummenacher@sti2.at
 * gerald.schrempf@sti2.at (development)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301, USA.
 */package at.sti2.semanticspaces.api.spaceOntology;

import org.ontoware.rdf2go.model.node.URI;
import org.ontoware.rdf2go.model.node.impl.URIImpl;


/**
 * TS ontology constants
 * @author Michael Fried
 */
public class SpaceOntology {

    public final static URI metadataSpace = new URIImpl("ts://metadata-space");
    public final static URI rootSpace = new URIImpl("ts://rootspace");
    
	public final static URI tsonto = new URIImpl("http://www.soa4all.eu/ontologies/tsonto#");
	
    // internal space relations as URI
    public final static URI tsonto_isTypeOf = new URIImpl(tsonto + "isTypeOf");
	
    // SpaceModelTypes
    public final static URI spaceModelTypes = new URIImpl(tsonto + "SpaceModelTypes/");
    
	// structural meta-data 
	public final static URI rdf = new URIImpl("http://www.w3.org/1999/02/22-rdf-syntax-ns#");
	public final static URI rdfs = new URIImpl("http://www.w3.org/2000/01/rdf-schema#");
	public final static URI xsd = new URIImpl("http://www.w3.org/2001/XMLSchema#");
	public final static URI foaf = new URIImpl("http://xmlns.com/foaf/0.1/");
	public final static URI dc = new URIImpl("http://purl.org/dc/elements/1.1/");
	public final static URI part = new URIImpl("http://www.w3.org/2001/sw/BestPractices/OEP/SimplePartWhole/part.owl#");
	public final static URI ql = new URIImpl("http://www.w3.org/2004/12/ql#");
	public final static URI yars = new URIImpl("http://sw.deri.org/2004/06/yars#");
	public final static URI rdfs_isDefinedBy  = new URIImpl(rdfs + "isDefinedBy");
	public final static URI dc_date = new URIImpl(dc + "date");

	// structural relations between spaces
	
	// AccessLogEntryURI
	public final static URI ALE_URIBase = new URIImpl(tsonto + "AccessLogEntryURI/");

	// AccessLogEntry
	public final static URI ALE_CLIENT = new URIImpl(dc + "publisher");
	public final static URI ALE_DATE = new URIImpl(dc + "date");
	public final static URI ALE_TYPE = new URIImpl(tsonto + "AccessLogEntry/type");

	// AccessType
	public final static URI ALEwrite = new URIImpl(ALE_TYPE + "/write");
	public final static URI ALEread = new URIImpl(ALE_TYPE + "/read");
	public final static URI ALEquery = new URIImpl(ALE_TYPE + "/query");
	public final static URI ALEtake = new URIImpl(ALE_TYPE + "/take");
}
