package at.sti2.semanticspaces.impl.model;

import java.util.Iterator;

import org.ontoware.aifbcommons.collection.ClosableIterable;
import org.ontoware.aifbcommons.collection.ClosableIterator;

/**
 * flattens many ClosableIterables to one ClosableIterable.
 * 
 * @author Gerald Schrempf
 *
 * @param <T>
 */

public class FlattenClosableIterable<T> implements ClosableIterable<T> {
	private static final long serialVersionUID = 1L;
	private Iterator<ClosableIterator<T>> iterator;

	public FlattenClosableIterable(Iterator<ClosableIterator<T>> iterators) {
		iterator = iterators;
	}

	@Override
	public ClosableIterator<T> iterator() {
		return new FlattenClosableIterator<T>(iterator);
	}
}
