package at.sti2.semanticspaces.impl.model;

import java.util.Iterator;
import java.util.List;

import org.ontoware.aifbcommons.collection.ClosableIterator;
import org.ontoware.rdf2go.model.QueryResultTable;
import org.ontoware.rdf2go.model.QueryRow;

/**
 * flattens many QueryResultTables to one QueryResultTable
 * @author Gerald Schrempf
 *
 */

public class FlattenQueryResultTable extends FlattenClosableIterable<QueryRow> implements QueryResultTable {
	private static final long serialVersionUID = 1L;
	private List<String> variables;


	public FlattenQueryResultTable(List<String> variables,
			Iterator<ClosableIterator<QueryRow>> iterator) {
		super(iterator);
		this.variables = variables;
	}

	public List<String> getVariables() {
		return variables;
	}
}
