/*
 * Copyright (C) 2010
 * 
 * STI Innsbruck ICT - Technologie Park Innsbruck, 2nd Floor Technikerstrasse
 * 21a A-6020 Innsbruck, Austria
 * 
 * Contact: reto.krummenacher@sti2.at gerald.schrempf@sti2.at (development)
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

package at.sti2.semanticspaces.impl.queries;


import org.ontoware.rdf2go.model.node.URI;


/**
 * Since a space refers to a graph a query String must have the graph inside the query. 
 * 
 * @author Michael Fried
 */
public class SelectQuery extends SparqlQuery {

    
	/**
     * @param query the raw query string
     */
	public SelectQuery(URI spaceURI, String query) {
        super(spaceURI, query);
    }

	/**
     * adds the space uri as graph to the query
     * 
     * @return query String representation including graph
     */
	@Override
	public String toString() {
		//TODO from named???
		if(queryString.replaceAll(" ", "").toLowerCase().contains("graph<")) {
			return queryString;
		} else {
			String[] stringSpl = queryString.split("\\s[Ww][Hh][Ee][Rr][Ee]");
			if(stringSpl.length > 1){
				String queryCalcString = stringSpl[0] + " { GRAPH <" + super.spaceURI + "> ";
				
				boolean isSetKlammer = false;
				for (int j = 1; j < stringSpl.length; j++) {
					if(stringSpl[j].contains("}") && isSetKlammer == false){
						stringSpl[j] = stringSpl[j].replaceFirst("}", "} }");
						isSetKlammer = true;
					}
					queryCalcString += stringSpl[j];
				}

				return queryCalcString;
			} else {
				return queryString;
			}
		}
	}

}
